// this tab/file contains the actual animation subroutines

// This version of bouncer has 3 sprites bouncing around the cube
void bouncer1() {
  sprite mySprite1(2, 2, 2);
  sprite mySprite2(2, 2, 2);
  sprite mySprite3(2, 2, 2);
  mySprite1.assignplace(1, 1, 3);
  mySprite2.assignplace(0, 4, 4);
  mySprite3.assignplace(4, 4, 0);
  mySprite1.assignmotion(1, 2, 1);
  mySprite2.assignmotion(1, -1, -2);
  mySprite3.assignmotion(-2, -1, -1);
  for (int j = 0; j < 120; j++) {
    mySprite1.fillIt();
    mySprite2.fillIt();
    //  mySprite3.fillIt();
    mySprite1.bounceIt();
    delay(30);
    mySprite2.bounceIt();
    delay(30);
    //  mySprite3.bounceIt();
    //  delay(30);
  }
  pause();
}

// Another animations using the sprite object class
// More boxes, but not concentic. These just pop into
// and out of existence with different colors and sizes.
void miniCubes() {
  sprite mysprite1(2, 2, 2);
  sprite mysprite2(3, 3, 3);
  sprite mysprite3(2, 2, 2);
  for (int j = 35; j < 75; j++) {
    mysprite1.fillIt();
    mysprite1.assignplace(random(7), random(7), random(7));
    mysprite1.setIt();
    delay(120 - j);

    mysprite2.fillIt();
    mysprite2.assignplace(random(6), random(6), random(6));
    mysprite2.setIt();
    delay(120 - j);

    mysprite3.fillIt();
    mysprite3.assignplace(random(7), random(7), random(7));
    mysprite3.setIt();
    delay(120 - j);
    mysprite1.clearIt();
    mysprite2.clearIt();
    mysprite3.clearIt();
  }
  pause();
}




// ***************************** Start of Flying Boxes ******************************************
// Using the sprite object class
void FlyingBoxes() {
  sprite mySprite(3, 3, 3); // this creates a sprite called mySprite with  dimensions 2x2x2 LEDs.
  mySprite.fillIt();
  mySprite.place[0] = 3; mySprite.place[1] = 5; mySprite.place[2] = 3;
  mySprite.setIt(); // actually puts it in the cube, turning on the LEDs.
  mySprite.motion[0] = 2; mySprite.motion[1] = 1; mySprite.motion[2] = 1;

  sprite mySprite2(3, 3, 3); // this creates a sprite called mySprite with  dimensions 2x2x2 LEDs.
  mySprite2.fillIt();
  mySprite2.place[0] = 0; mySprite2.place[1] = 3; mySprite2.place[2] = 2;
  mySprite2.setIt(); // actually puts it in the cube, turning on the LEDs.
  mySprite2.motion[0] = 2; mySprite2.motion[1] = 1; mySprite2.motion[2] = 1;

  sprite mySprite3(3, 3, 3); // this creates a sprite called mySprite with  dimensions 2x2x2 LEDs.
  mySprite3.fillIt();
  mySprite3.place[0] = 4; mySprite3.place[1] = 2; mySprite3.place[2] = 4;
  mySprite3.setIt(); // actually puts it in the cube, turning on the LEDs.
  mySprite3.motion[0] = 2; mySprite3.motion[1] = 1; mySprite3.motion[2] = 1;

  for (int count = 0; count < 150; count++) { // loop around 100 times
    mySprite.rollX(1);
    mySprite2.rollZ(1);
    mySprite3.rollY(0);
    delay(30); // wait 1/10th second before next move.
  }
  mySprite.clearIt(); // turn off the sprite since we're done.
  mySprite2.clearIt(); // turn off the sprite since we're done.
  mySprite3.clearIt(); // turn off the sprite since we're done.
  delay(1000);
}
// ***************************** End of Flying Boxes ******************************************
// ***************************** Start of Rolling Ball ******************************************
// uses the sprite object class
void RollingBall() {
  // This created the sprite and rolls it around the cube.
  // The sprite is rotated around the axis, and then
  // gradually moved back and forth on the x axis.
  int color;
  sprite mySprite(4, 4, 4);
  mySprite.sphere();;
  mySprite.place[0] = -1;
  mySprite.place[1] = 1;
  mySprite.place[2] = 1;
  for (int x = 0; x < 131; x++) {
    if (x > 15) {
      clearCube();
      mySprite.place[0] = 0;
    }
    if (x > 30) {
      clearCube();
      mySprite.place[0] = 1;
    }
    if (x > 45) {
      clearCube();
      mySprite.place[0] = 2;
    }
    if (x > 60) {
      clearCube();
      mySprite.place[0] = 3;
    }
    if (x > 75) {
      clearCube();
      mySprite.place[0] = 4;
    }
    if (x > 90) {
      clearCube();
      mySprite.place[0] = 3;
    }
    if (x > 105) {
      clearCube();
      mySprite.place[0] = 2;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[0] = 1;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[0] = 0;
    }
    mySprite.rollX(0);
    delay(20);
  }
  mySprite.clearIt();
  for (int x = 0; x < 126; x++) {
    if (x > 15) {
      clearCube();
      mySprite.place[1] = 0;
    }
    if (x > 30) {
      clearCube();
      mySprite.place[1] = 1;
    }
    if (x > 45) {
      clearCube();
      mySprite.place[1] = 2;
    }
    if (x > 60) {
      clearCube();
      mySprite.place[1] = 3;
    }
    if (x > 75) {
      clearCube();
      mySprite.place[1] = 4;
    }
    if (x > 90) {
      clearCube();
      mySprite.place[1] = 3;
    }
    if (x > 105) {
      clearCube();
      mySprite.place[1] = 2;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[1] = 1;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[1] = 0;
    }
    mySprite.rollY(0);
    delay(20);
  }
  clearCube();
  for (int x = 0; x < 131; x++) {
    if (x > 15) {
      clearCube();
      mySprite.place[2] = 0;
    }
    if (x > 30) {
      clearCube();
      mySprite.place[2] = 1;
    }
    if (x > 45) {
      clearCube();
      mySprite.place[2] = 2;
    }
    if (x > 60) {
      clearCube();
      mySprite.place[2] = 3;
    }
    if (x > 75) {
      clearCube();
      mySprite.place[2] = 4;
    }
    if (x > 90) {
      clearCube();
      mySprite.place[2] = 3;
    }
    if (x > 105) {
      clearCube();
      mySprite.place[2] = 2;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[2] = 1;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[2] = 0;
    }
    mySprite.rollZ(0);
    delay(20);
  }
  pause();
}
// ***************************** End of Rolling Ball ******************************************
// ***************************** Start of Sparkles ******************************************
// very simple animation - three LEDs in the cube are lit at random, when a 4th is lit, the 1st one is turned off
// then a 5th is lit and the 2nd one goes off, etc. etc.
void sparkles() {
  for (int j = 0; j < 125; j++) { // go around 75 times
    int newx1, newy1, newz1, newx2, newy2, newz2, newx3, newy3, newz3; // locations for 3 LEDs that are on at one time
    newx1 = random(8);
    newy1 = random(8);
    newz1 = random(8);
    ledOn(newx1, newy1, newz1); // create the first
    delay(8);
    ledOff(newx2, newy2, newz2);  // turn off the second
    newx2 = random(8);
    newy2 = random(8);
    newz2 = random(8);
    ledOn(newx2, newy2, newz2); // create the first  // create the second
    delay(8);
    ledOff(newx3, newy3, newz3);// turn off the third
    newx3 = random(8);
    newy3 = random(8);
    newz3 = random(8);
    ledOn(newx3, newy3, newz3); // create the first  // create the third
    delay(8);
    ledOff(newx1, newy1, newz1);  // turn off the first
  }
  pause();
}
// ***************************** End of Sparkles ******************************************
// ***************************** Start Warp Ribbon *****************************************
void warpRibbon() {
  int z;
  for (int j = 0; j < 6; j++) {
    for (int i = 0; i < 36; i++) { //it takes 36 steps to complete one full cycle
      for (byte xx = 0; xx < 8; xx++) {
        for (byte yy = 0; yy < 8; yy++) {
          z = ((byte)(4 + cos((xx / 7.23) + (yy / 7.23) + (float)i / 6.28) * 4)); // the  actual z calculation
          if (z > 7) {
            z = 7;
          }
          ledOn(xx, yy, z);
        }
      }
      delay(3);       // Increase or decrease to change speed of this  animation
      clearCube();    // clear the cube
    }

    for (int i = 0; i < 36; i++) { //it takes 36 steps to complete one full cycle
      for (byte xx = 0; xx < 8; xx++) {
        for (byte yy = 0; yy < 8; yy++) {
          z = ((byte)(4 + cos((xx / 7.23) + (yy / 12.23) + (float)i / 6.28) * 4)); // the  actual z calculation
          if (z > 7) {
            z = 7;
          }
          ledOn(7 - xx, yy, z);
        }
      }
      delay(3);       // Increase or decrease to change speed of this  animation
      clearCube();    // clear the cube
    }
  }
  pause();
}
// ***************************** End Warp Ribbon *****************************************
// ***************************** Start of Cube Flash ******************************************
// the cube grows and shrinks as various layers are turned on
void cubeFlash() {
  for (int mytime = 7; mytime > 0; mytime--) {
    cubeInCube(0);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(3);
    showCube(mytime * 2);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(0);
    showCube(mytime);
    clearCube();
    showCube(mytime * 2);
  }
  for (int k = 0; k < 4; k++) {
    int mytime = 1;
    cubeInCube(0);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(3);
    showCube(mytime * 2);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(0);
    showCube(mytime);
    clearCube();
    showCube(mytime * 2);
  }
  for (int mytime = 2; mytime < 8; mytime++) {
    cubeInCube(0);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(3);
    showCube(mytime * 2);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(0);
    showCube(mytime);
    clearCube();
    showCube(mytime * 2);
  }
  pause();

}
// generate patterns from center of the cube
void cubeInCube(int k) {
  switch (k) {
    case 0:   // turn on center LED only
      for (int layer = 3; layer < 5; layer++) {
        for (int column = 3; column < 5; column++) {
          for (int row = 3; row < 5; row++) {
            ledOn(column, row, layer);
          }
        }
      }
      break;
    case 1:    // turn on all but outside layers of cube
      for (int layer = 2; layer < 6; layer++) {
        for (int column = 2; column < 6; column++) {
          for (int row = 2; row < 6; row++) {
            ledOn(column, row, layer);
          }
        }
      }
      for (int layer = 3; layer < 5; layer++) {
        for (int column = 3; column < 5; column++) {
          for (int row = 3; row < 5; row++) {
            ledOff(column, row, layer);
          }
        }
      }
      break;
    case 2:  // turn on whole cube
      for (int layer = 1; layer < 7; layer++) {
        for (int column = 1; column < 7; column++) {
          for (int row = 1; row < 7; row++) {
            ledOn(column, row, layer);
          }
        }
      }
      for (int layer = 2; layer < 6; layer++) {
        for (int column = 2; column < 6; column++) {
          for (int row = 2; row < 6; row++) {
            ledOff(column, row, layer);
          }
        }
      }
      break;
    case 3:  // turn on whole cube
      for (int layer = 0; layer < 8; layer++) {
        for (int column = 0; column < 8; column++) {
          for (int row = 0; row < 8; row++) {
            ledOn(column, row, layer);
          }
        }
      }
      for (int layer = 1; layer < 7; layer++) {
        for (int column = 1; column < 7; column++) {
          for (int row = 1; row < 7; row++) {
            ledOff(column, row, layer);
          }
        }
      }
      break;
  }
}
// ***************************** End of Cube Flash ******************************************
// ***************************** Start of Rain ******************************************
// a very simple animation - random LED are lit on top layer and fall like rain through the cube
void rainStorm() {
  for (int k = 0; k < 50; k++) {
    if (k % 2) {
      int myx = random(8);
      int myy = random(8);
      ledOn(myx, myy, 7);
    }
    delay(70);
    copyDown();
  }
  for (int k = 0; k < 50; k++) {
    int myx = random(8);
    int myy = random(8);
    ledOn(myx, myy, 7);
    myx = random(8);
    myy = random(8);
    ledOn(myx, myy, 7);
    delay(70);
    copyDown();
  }
  for (int k = 0; k < 50; k++) {
    if (k % 2) {
      int myx = random(8);
      int myy = random(8);
      ledOn(myx, myy, 7);
    }
    delay(70);
    copyDown();
  }
  pause();
}
// ***************************** End of Rain ******************************************
// ***************************** Beginning of Rotary ******************************************
// a vertical panel is spun around the center of the cube
void rotary() {
  for (int k = 0; k < 3; k++) {
    for (int j = 7; j > 0; j--) {
      rotCenter(j);
    }
    for (int j = 8; j > -1; j--) {
      rotCenter(j);
    }
    for (int j = 7; j > 0; j--) {
      rotCenter(j);
    }
    for (int j = 8; j > -1; j--) {
      rotCenter(j);
    }
    for (int j = 0; j < 8; j++) {
      rotCenter(j);
    }
    for (int j = 0; j < 9; j++) {
      rotCenter(j);
    }
    for (int j = 0; j < 8; j++) {
      rotCenter(j);
    }
    for (int j = 0; j < 9; j++) {
      rotCenter(j);
    }
  }
  pause();
}

// routine that does the rotatation
void rotCenter(int k) {
  switch (k) {
    case 0:
      for (int z = 0; z < 8; z++) {
        for (int x = 0; x < 8; x++) {
          ledOn(x, x, z);
        }
      }
      break;
    case 1:
      for (int z = 0; z < 8; z++) {
        ledOn(0, 1, z);
        ledOn(1, 1, z);
        ledOn(2, 2, z);
        ledOn(3, 3, z);
        ledOn(4, 3, z);
        ledOn(5, 4, z);
        ledOn(6, 5, z);
        ledOn(7, 5, z);
      }
      break;
    case 2:
      for (int z = 0; z < 8; z++) {
        ledOn(0, 2, z);
        ledOn(1, 2, z);
        ledOn(2, 2, z);
        ledOn(3, 2, z);
        ledOn(4, 2, z);
        ledOn(5, 2, z);
        ledOn(6, 2, z);
        ledOn(7, 2, z);
      }
      break;
    case 3:
      for (int z = 0; z < 8; z++) {
        ledOn(0, 5, z);
        ledOn(1, 5, z);
        ledOn(2, 4, z);
        ledOn(3, 4, z);
        ledOn(4, 3, z);
        ledOn(5, 2, z);
        ledOn(6, 2, z);
        ledOn(7, 1, z);
      }
      break;
    case 4:
      for (int z = 0; z < 8; z++) {
        ledOn(0, 7, z);
        ledOn(1, 6, z);
        ledOn(2, 5, z);
        ledOn(3, 4, z);
        ledOn(4, 3, z);
        ledOn(5, 2, z);
        ledOn(6, 1, z);
        ledOn(7, 0, z);
      }
      break;
    case 5:
      for (int z = 0; z < 8; z++) {
        ledOn(1, 7, z);
        ledOn(1, 6, z);
        ledOn(2, 5, z);
        ledOn(3, 4, z);
        ledOn(3, 3, z);
        ledOn(4, 2, z);
        ledOn(5, 1, z);
        ledOn(5, 0, z);
      }
      break;
    case 6:
      for (int z = 0; z < 8; z++) {

        ledOn(2, 0, z);
        ledOn(2, 1, z);
        ledOn(2, 2, z);
        ledOn(2, 3, z);
        ledOn(2, 4, z);
        ledOn(2, 5, z);
        ledOn(2, 6, z);
        ledOn(2, 7, z);
      }
      break;
    case 7:
      for (int z = 0; z < 8; z++) {

        ledOn(1, 0, z);
        ledOn(2, 1, z);
        ledOn(2, 2, z);
        ledOn(3, 3, z);
        ledOn(3, 4, z);
        ledOn(4, 5, z);
        ledOn(5, 6, z);
        ledOn(5, 7, z);
      }
      break;
    case 8:
      for (int z = 0; z < 8; z++) {
        for (int x = 0; x < 8; x++) {
          ledOn(x, x, z);
        }
      }
      break;
  }
  showCube(3);
}
// ***************************** End of Rotary ******************************************
// ***************************** Begin Swings ******************************************
// This is the series of calls to the SwingAll subroutine.
void swings() {
  int myTime = 5;
  swingAll("1f", "xx", "xx", myTime);
  swingAll("4f", "xx", "xx", myTime);
  swingAll("3f", "xx", "xx", myTime);
  swingAll("2f", "xx", "xx", myTime);
  swingAll("2r", "xx", "xx", myTime);
  swingAll("3r", "xx", "xx", myTime);
  swingAll("4r", "xx", "xx", myTime);
  swingAll("1r", "xx", "xx", myTime);
  swingAll("pfy", "xx", "xx", myTime);
  swingAll("pry", "xx", "xx", myTime);
  swingAll("xx", "1f", "xx", myTime);
  swingAll("xx", "4f", "xx", myTime);
  swingAll("xx", "3f", "xx", myTime);
  swingAll("xx", "2f", "xx", myTime);
  swingAll("xx", "2r", "xx", myTime);
  swingAll("xx", "3r", "xx", myTime);
  swingAll("xx", "4r", "xx", myTime);
  swingAll("xx", "1r", "xx", myTime);
  swingAll("xx", "pfx", "xx", myTime);
  swingAll("xx", "prx", "xx", myTime);
  swingAll("xx", "xx", "1f", myTime);
  swingAll("xx", "xx", "4f", myTime);
  swingAll("xx", "xx", "3f", myTime);
  swingAll("xx", "xx", "2f", myTime);
  swingAll("xx", "xx", "2r", myTime);
  swingAll("xx", "xx", "3r", myTime);
  swingAll("xx", "xx", "4r", myTime);
  swingAll("xx", "xx", "1r", myTime);
  swingAll("xx", "xx", "pfx", myTime);
  swingAll("xx", "xx", "prx", myTime);
  swingAll("2r", "xx", "1f", myTime);
  swingAll("3r", "xx", "4f", myTime);
  swingAll("4r", "xx", "3f", myTime);
  swingAll("1r", "xx", "2f", myTime);
  swingAll("1f", "xx", "1f", myTime);
  swingAll("4f", "xx", "4f", myTime);
  swingAll("3f", "xx", "3f", myTime);
  swingAll("2f", "xx", "2f", myTime);
  swingAll("xx", "1f", "2r", myTime);
  swingAll("xx", "4f", "3r", myTime);
  swingAll("xx", "3f", "4r", myTime);
  swingAll("xx", "2f", "1r", myTime);
  swingAll("xx", "1f", "1f", myTime);
  swingAll("xx", "4f", "4f", myTime);
  swingAll("xx", "3f", "3f", myTime);
  swingAll("xx", "2f", "2f", myTime);
  swingAll("2r", "1f", "xx", myTime);
  swingAll("3r", "4f", "xx", myTime);
  swingAll("4r", "3f", "xx", myTime);
  swingAll("1r", "2f", "xx", myTime);
  swingAll("1f", "2r", "xx", myTime);
  swingAll("4f", "3r", "xx", myTime);
  swingAll("3f", "4r", "xx", myTime);
  swingAll("2f", "1r", "xx", myTime);
  swingAll("1f", "xx", "xx", myTime);
  swingAll("4f", "xx", "xx", myTime);
  swingAll("3f", "xx", "xx", myTime);
  swingAll("2f", "xx", "xx", myTime);
  swingAll("2r", "xx", "xx", myTime);
  swingAll("3r", "xx", "xx", myTime);
  swingAll("4r", "xx", "xx", myTime);
  swingAll("1r", "xx", "xx", myTime);
  swingAll("xx", "1f", "xx", myTime);
  swingAll("xx", "4f", "xx", myTime);
  swingAll("xx", "3f", "xx", myTime);
  swingAll("xx", "2f", "xx", myTime);
  swingAll("xx", "2r", "xx", myTime);
  swingAll("xx", "3r", "xx", myTime);
  swingAll("xx", "4r", "xx", myTime);
  swingAll("xx", "1r", "xx", myTime);
  swingAll("xx", "xx", "1f", myTime);
  swingAll("xx", "xx", "4f", myTime);
  swingAll("xx", "xx", "3f", myTime);
  swingAll("xx", "xx", "2f", myTime);
  swingAll("xx", "xx", "2r", myTime);
  swingAll("xx", "xx", "3r", myTime);
  swingAll("xx", "xx", "4r", myTime);
  swingAll("xx", "xx", "1r", myTime);
  pause();
}

// This is a subroutine that swings three sheets of LEDs from one face of the cube to another.  The string input
// tells the routine the corner which we are going to swing from, and direction of
// rotation.  The time input in milliseconds between steps.
// It also has some options to sent the sheet straight across the cube instead of swinging. These
// start with a p and then specify the direction and plane of movement.
void swingAll(String RedString, String GreenString, String BlueString, int myTime) {

  for (int i = 0; i < 8; i++) {
    for (int z = 0; z < 8; z++) {
      for (int x = 0; x < 8; x++) {
        // do it all around the z axis
        if (BlueString == "1r") {
          ledOn(x, diagonal[x][i], z);
        }
        else if (BlueString == "1f") {
          ledOn(diagonal[7 - x][i], 7 - x, z);
        }
        else if (BlueString == "2f") {
          ledOn(x, 7 - diagonal[x][i], z);
        }
        else if (BlueString == "2r") {
          ledOn(diagonal[7 - x][i], x, z);
        }
        else if (BlueString == "3r") {
          ledOn(7 - x, 7 - diagonal[x][i], z);
        }
        else if (BlueString == "3f") {
          ledOn(7 - diagonal[7 - x][i], x, z);
        }
        else if (BlueString == "4f") {
          ledOn(7 - x, diagonal[x][i], z);
        }
        else if (BlueString == "4r") {
          ledOn(7 - diagonal[7 - x][i], 7 - x, z);
        }
        else if (BlueString == "pfy") {
          ledOn(x, i / 2, z);
        }
        else if (BlueString == "pry") {
          ledOn(x, 7 - (i / 2), z);
        }
        else if (BlueString == "pfx") {
          ledOn(i / 2, x, z);
        }
        else if (BlueString == "prx") {
          ledOn(7 - (i / 2), x, z);
        }
        // now do it all again around the x axis
        if (RedString == "1r") {
          ledOn(z, x, diagonal[x][i]);
        }
        else if (RedString == "1f") {
          ledOn(z, diagonal[7 - x][i], 7 - x);
        }
        else if (RedString == "2f") {
          ledOn(z, x, 7 - diagonal[x][i]);
        }
        else if (RedString == "2r") {
          ledOn(z, diagonal[7 - x][i], x);
        }
        else if (RedString == "3r") {
          ledOn(z, 7 - x, 7 - diagonal[x][i]);
        }
        else if (RedString == "3f") {
          ledOn(z, 7 - diagonal[7 - x][i], x);
        }
        else if (RedString == "4f") {
          ledOn(z, 7 - x, diagonal[x][i]);
        }
        else if (RedString == "4r") {
          ledOn(z, 7 - diagonal[7 - x][i], 7 - x);
        }
        else if (RedString == "pfy") {
          ledOn(x, i / 2, z);
        }
        else if (RedString == "pry") {
          ledOn(x, 7 - (i / 2), z);
        }
        else if (RedString == "pfz") {
          ledOn(x, z, i / 2);
        }
        else if (RedString == "prz") {
          ledOn(x, z, 7 - (i / 2));
        }
        // now do it all again around the y axis
        if (GreenString == "1r") {
          ledOn(x, z, diagonal[x][i]);
        }
        else if (GreenString == "1f") {
          ledOn(diagonal[7 - x][i], z, 7 - x);
        }
        else if (GreenString == "2f") {
          ledOn(x, z, 7 - diagonal[x][i]);
        }
        else if (GreenString == "2r") {
          ledOn(diagonal[7 - x][i], z, x);
        }
        else if (GreenString == "3r") {
          ledOn(7 - x, z, 7 - diagonal[x][i]);
        }
        else if (GreenString == "3f") {
          ledOn(7 - diagonal[7 - x][i], z, x);
        }
        else if (GreenString == "4f") {
          ledOn(7 - x, z, diagonal[x][i]);
        }
        else if (GreenString == "4r") {
          ledOn(7 - diagonal[7 - x][i], z, 7 - x);
        }
        else if (GreenString == "pfx") {
          ledOn(i / 2, x, z);
        }
        else if (GreenString == "prx") {
          ledOn(7 - (i / 2), x, z);
        }
        else if (GreenString == "pfz") {
          ledOn(x, z, i / 2);
        }
        else if (GreenString == "prz") {
          ledOn(x, z, 7 - (i / 2));
        }
      }
    }
    delay(myTime);
    clearCube();
  }

  for (int i = 6; i > -1; i--) {
    for (int z = 0; z < 8; z++) {
      for (int x = 0; x < 8; x++) {
        // do it all around the z axis
        if (BlueString == "1r") {
          ledOn(diagonal[x][i], x, z);
        }
        else if (BlueString == "1f") {
          ledOn(7 - x, diagonal[7 - x][i], z);
        }
        else  if (BlueString == "2f") {
          ledOn(diagonal[x][i], 7 - x, z);
        }
        else  if (BlueString == "2r") {
          ledOn(7 - x, 7 - diagonal[7 - x][i], z);
        }
        else if (BlueString == "3r") {
          ledOn(7 - diagonal[x][i], 7 - x, z);
        }
        else if (BlueString == "3f") {
          ledOn(x, 7 - diagonal[7 - x][i], z);
        }
        else if (BlueString == "4f") {
          ledOn(7 - diagonal[x][i], x, z);
        }
        else if (BlueString == "4r") {
          ledOn(x, diagonal[7 - x][i], z);
        }
        else if (BlueString == "pfy") {
          ledOn(x, 3 + (7 - i) / 2, z);
        }
        else if (BlueString == "pry") {
          ledOn(x, 4 - (7 - i) / 2, z);
        }
        else if (BlueString == "pfx") {
          ledOn(3 + (7 - i) / 2, x, z);
        }
        else if (BlueString == "prx") {
          ledOn(4 - (7 - i) / 2, x, z);
        }
        // now do it all again around the x axis
        if (RedString == "1r") {
          ledOn(z, diagonal[x][i], x);
        }
        else if (RedString == "1f") {
          ledOn(z, 7 - x, diagonal[7 - x][i]);
        }
        else if (RedString == "2f") {
          ledOn(z, diagonal[x][i], 7 - x);
        }
        else if (RedString == "2r") {
          ledOn(z, 7 - x, 7 - diagonal[7 - x][i]);
        }
        else if (RedString == "3r") {
          ledOn(z, 7 - diagonal[x][i], 7 - x);
        }
        else if (RedString == "3f") {
          ledOn(z, x, 7 - diagonal[7 - x][i]);
        }
        else if (RedString == "4f") {
          ledOn(z, 7 - diagonal[x][i], x);
        }
        else if (RedString == "4r") {
          ledOn(z, x, diagonal[7 - x][i]);
        }
        else if (RedString == "pfy") {
          ledOn(x, 3 + (7 - i) / 2, z);
        }
        else if (RedString == "pry") {
          ledOn(x, 4 - (7 - i) / 2, z);
        }
        else if (RedString == "pfz") {
          ledOn(x, z, 3 + (7 - i) / 2);
        }
        else if (RedString == "prz") {
          ledOn(x, z, 4 - (7 - i) / 2);
        }

        // now do it all again around the y axis
        if (GreenString == "1r") {
          ledOn(diagonal[x][i], z, x);
        }
        else if (GreenString == "1f") {
          ledOn(7 - x, z, diagonal[7 - x][i]);
        }
        else if (GreenString == "2f") {
          ledOn(diagonal[x][i], z, 7 - x);
        }
        else if (GreenString == "2r") {
          ledOn(7 - x, z, 7 - diagonal[7 - x][i]);
        }
        else if (GreenString == "3r") {
          ledOn(7 - diagonal[x][i], z, 7 - x);
        }
        else if (GreenString == "3f") {
          ledOn(x, z, 7 - diagonal[7 - x][i]);
        }
        else if (GreenString == "4f") {
          ledOn(7 - diagonal[x][i], z, x);
        }
        else if (GreenString == "4r") {
          ledOn(x, z, diagonal[7 - x][i]);
        }
        else if (GreenString == "pfx") {
          ledOn(3 + (7 - i) / 2, x, z);
        }
        else if (GreenString == "prx") {
          ledOn(4 - (7 - i) / 2, x, z);
        }
        else if (GreenString == "pfz") {
          ledOn(x, z, 3 + (7 - i) / 2);
        }
        else if (GreenString == "prz") {
          ledOn(x, z, 4 - (7 - i) / 2);
        }
      }
    }

    delay(myTime);
    clearCube();
  }
}
// ***************************** End Swings ******************************************
// ***************************** Begin Diamond Wave ******************************************
void diamondWave() {
  int z, z1;
  for (int j = 0; j < 15; j++) { // go up and down 15 times
    for (int i = 0; i < 18; i++) { // moving upward
      for (byte xx = 0; xx < 8; xx++) { // Here we generate both the upper and  lower pyramid
        for (byte yy = 0; yy < 8; yy++) { // If actually starts out as a cone, but  flairs out to a square at its widest.
          z = int(i - 9.5 + distance[xx][yy]);
          z1 = int(i - 0.5 - distance[xx][yy]);
          if (z > -1 && z < 8) {
            ledOn(xx, yy, z);
          }
          if (z1 > -1 && z1 < 8) {
            ledOn(xx, yy, z1);
          }
        }
      }
      delay(20);       // Increase or decrease to change speed of this  animation
      clearCube();    // clear the cube
    }
    for (int i = 16; i > 0; i--) { //moving downward

      for (byte xx = 0; xx < 8; xx++) { //
        for (byte yy = 0; yy < 8; yy++) {
          z = int(i - 9.5 + distance[xx][yy]);
          z1 = int(i - 0.5 - distance[xx][yy]);
          if (z > -1 && z < 8) {
            ledOn(xx, yy, z);
          }
          if (z1 > -1 && z1 < 8) {
            ledOn(xx, yy, z1);
          }
        }
      }
      delay(20);       // Increase or decrease to change speed of this  animation
      clearCube();    // clear the cube
    }
  }
  pause();
}
// ***************************** End Diamond Wave ******************************************
// ***************************** Begin Dancing Fireflys ******************************************
// we are moving a falling column around at random from the top of the cube.
void dancingFireflys() {
  int xpos = 4;
  int ypos = 4;
  int myrandom, count;
  for (int k = 0; k < 500; k++) {
    count++;
    myrandom = random(5);
    if (myrandom == 0) {
      xpos++;
    }
    if (myrandom == 1) {
      xpos--;
    }
    if (myrandom == 2) {
      ypos++;
    }
    if (myrandom == 3) {
      ypos--;
    }
    if (xpos < 0) {
      xpos = 1;
    }
    if (xpos > 7) {
      xpos = 6;
    }
    if (ypos < 0) {
      ypos = 1;
    }
    if (ypos > 7) {
      ypos = 6;
    }
    ledOn(xpos, ypos, 7);
    if (count % 2) copyDown();
    delay(15);
  }
  pause();
}
// ***************************** End Dancing Fireflys ******************************************
// ***************************** Beginning of Panels ******************************************
// the most basic of cube animations. An entire panel in x, y, z direction is turned on
// and then moved through the cube.
void panels() {
  for (int k = 0; k < 6; k++) {
    for (int z = 7; z > -1; z--) {
      for (int x = 0; x < 8; x++) {
        for (int y = 0; y < 8; y++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int z = 0; z < 8; z++) {
      for (int x = 0; x < 8; x++) {
        for (int y = 0; y < 8; y++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int x = 0; x < 8; x++) {
      for (int z = 0; z < 8; z++) {
        for (int y = 0; y < 8; y++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int x = 7; x > -1; x--) {
      for (int z = 0; z < 8; z++) {
        for (int y = 0; y < 8; y++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int y = 0; y < 8; y++) {
      for (int x = 0; x < 8; x++) {
        for (int z = 0; z < 8; z++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int y = 7; y > -1; y--) {
      for (int x = 0; x < 8; x++) {
        for (int z = 0; z < 8; z++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
  }
  pause();
}

// ***************************** End of Panels ******************************************
// ***************************** Start of Sphere ******************************************

void sphere() {
  float polar, x, y, z;
  byte cube [8][8][8]; // used by some animations
  for (byte layer = 0; layer < 8; layer++) { // scan thru each layer
    for (byte column = 0; column < 8; column++) { // scan thru every column
      for (byte panel = 0; panel < 8; panel++) { // scan thru every panel
        x = float(layer); // convert coordinates to floating point to compute distance from center of cube
        y = float(panel);
        z = float(column);
        cube[column][panel][layer] = 5 * sqrt((x - 3.5) * (x - 3.5) + (y - 3.5) * (y - 3.5) + (z - 3.5) * (z - 3.5)); // Calculate the distance
      }
    }
  }
  for (int counter = 0; counter < 20; counter++) {
    for ( int count = 0; count < 20; count++) { //expand
      for (byte layer = 0; layer < 8; layer++) { // scan thru each layer
        for (byte column = 0; column < 8; column++) { // scan thru every column
          for (byte panel = 0; panel < 8; panel++) { // scan thru every panel
            if (cube[column][panel][layer] < count) { // if an LED is inside the radius specified by count, turn it on.
              ledOn(column, panel, layer);
            }
            else { // otherwise turn it off
              ledOff(column, panel, layer);
            }
          }
        }
      }
      delay(5);
    }
    for (int count = 19; count > 0; count--) { //contract
      for (byte layer = 0; layer < 8; layer++) { // scan thru each layer
        for (byte column = 0; column < 8; column++) { // scan thru every column
          for (byte panel = 0; panel < 8; panel++) { // scan thru every panel
            if (cube[column][panel][layer] < count) { // if an LED is inside the radius specified by count, turn it on.
              ledOn(column, panel, layer);
            }
            else { // otherwise turn it off
              ledOff(column, panel, layer);
            }
          }
        }
      }
      delay(5);
    }
  }
  pause();
}
// ***************************** End of Sphere ******************************************
// ***************************** Start of Sinewave ******************************************
void sineWave() {
  byte z;
  float pi = 3.14159;
  for (int j = 0; j < 15; j++) {
    for (int i = 0; i < 40; i++) { //it takes 40 steps to complete one full cycle
      for (byte xx = 0; xx < 4; xx++) { // for 1 quadrant of the cube
        for (byte yy = 0; yy < 4; yy++) {
          // the next line is the guts of the calculation, where the z value is calculated both as a function of i and distance
          // from center of cube.  The calculation is time consuming, so we calculate it for only one quadrant and
          // then reflect it onto the other 3 quadrants.
          z = ((byte)((4 + sin(sqrt((3.5 - xx) * (3.5 - xx) + (3.5 - yy) * (3.5 - yy)) / 1.57 + (float)i / 6.28) * 4))); // the actual z calculation
          // 1.57 = max dist from center / pi   and 6.28 is 2*pi; 1st 4 centers in cube, 2nd 4 scales the sine
          ledOn(xx, yy, z); // put z into the proper place for each position in quadrant 1
          ledOn(7 - xx, 7 - yy, z); // put z into the proper place for each position in quatrant 3
          ledOn(7 - xx, yy, z); // put z into the proper place for each position in quatrant 2
          ledOn(xx, 7 - yy, z); // put z into the proper place for each position in quatrant 4
        }
      }
      delay(5);
      clearCube();    // clear the cube
    }
  }
  pause();
}
// ***************************** End of Sinewave ******************************************
