// this tab/file contains the actual animation subroutines

// This version of bouncer has 3 sprites bouncing around the cube
void bouncer1() {
  sprite mySprite1(2, 2, 2);
  sprite mySprite2(2, 2, 2);
  sprite mySprite3(2, 2, 2);
  mySprite1.assignplace(1, 1, 3);
  mySprite2.assignplace(0, 4, 4);
  mySprite3.assignplace(4, 4, 0);
  mySprite1.assignmotion(1, 2, 1);
  mySprite2.assignmotion(1, -1, -2);
  mySprite3.assignmotion(-2, -1, -1);
  for (int j = 0; j < 120; j++) {
    mySprite1.fillIt();
    mySprite2.fillIt();
    //  mySprite3.fillIt();
    mySprite1.bounceIt();
    delay(30);
    mySprite2.bounceIt();
    delay(30);
    //  mySprite3.bounceIt();
    //  delay(30);
  }
  pause();
}

// Another animations using the sprite object class
// More boxes, but not concentic. These just pop into
// and out of existence with different colors and sizes.
void miniCubes() {
  sprite mysprite1(2, 2, 2);
  sprite mysprite2(3, 3, 3);
  sprite mysprite3(2, 2, 2);
  for (int j = 35; j < 75; j++) {
    mysprite1.fillIt();
    mysprite1.assignplace(random(7), random(7), random(7));
    mysprite1.setIt();
    delay(120 - j);

    mysprite2.fillIt();
    mysprite2.assignplace(random(6), random(6), random(6));
    mysprite2.setIt();
    delay(120 - j);

    mysprite3.fillIt();
    mysprite3.assignplace(random(7), random(7), random(7));
    mysprite3.setIt();
    delay(120 - j);
    mysprite1.clearIt();
    mysprite2.clearIt();
    mysprite3.clearIt();
  }
  pause();
}




// ***************************** Start of Flying Boxes ******************************************
// Using the sprite object class
void FlyingBoxes() {
  sprite mySprite(3, 3, 3); // this creates a sprite called mySprite with  dimensions 2x2x2 LEDs.
  mySprite.fillIt();
  mySprite.place[0] = 3; mySprite.place[1] = 5; mySprite.place[2] = 3;
  mySprite.setIt(); // actually puts it in the cube, turning on the LEDs.
  mySprite.motion[0] = 2; mySprite.motion[1] = 1; mySprite.motion[2] = 1;

  sprite mySprite2(3, 3, 3); // this creates a sprite called mySprite with  dimensions 2x2x2 LEDs.
  mySprite2.fillIt();
  mySprite2.place[0] = 0; mySprite2.place[1] = 3; mySprite2.place[2] = 2;
  mySprite2.setIt(); // actually puts it in the cube, turning on the LEDs.
  mySprite2.motion[0] = 2; mySprite2.motion[1] = 1; mySprite2.motion[2] = 1;

  sprite mySprite3(3, 3, 3); // this creates a sprite called mySprite with  dimensions 2x2x2 LEDs.
  mySprite3.fillIt();
  mySprite3.place[0] = 4; mySprite3.place[1] = 2; mySprite3.place[2] = 4;
  mySprite3.setIt(); // actually puts it in the cube, turning on the LEDs.
  mySprite3.motion[0] = 2; mySprite3.motion[1] = 1; mySprite3.motion[2] = 1;

  for (int count = 0; count < 150; count++) { // loop around 100 times
    mySprite.rollX(1);
    mySprite2.rollZ(1);
    mySprite3.rollY(0);
    delay(30); // wait 1/10th second before next move.
  }
  mySprite.clearIt(); // turn off the sprite since we're done.
  mySprite2.clearIt(); // turn off the sprite since we're done.
  mySprite3.clearIt(); // turn off the sprite since we're done.
  delay(1000);
}
// ***************************** End of Flying Boxes ******************************************
// ***************************** Start of Rolling Ball ******************************************
// uses the sprite object class
void RollingBall() {
  // This created the sprite and rolls it around the cube.
  // The sprite is rotated around the axis, and then
  // gradually moved back and forth on the x axis.
  int color;
  sprite mySprite(4, 4, 4);
  mySprite.sphere();;
  mySprite.place[0] = -1;
  mySprite.place[1] = 1;
  mySprite.place[2] = 1;
  for (int x = 0; x < 131; x++) {
    if (x > 15) {
      clearCube();
      mySprite.place[0] = 0;
    }
    if (x > 30) {
      clearCube();
      mySprite.place[0] = 1;
    }
    if (x > 45) {
      clearCube();
      mySprite.place[0] = 2;
    }
    if (x > 60) {
      clearCube();
      mySprite.place[0] = 3;
    }
    if (x > 75) {
      clearCube();
      mySprite.place[0] = 4;
    }
    if (x > 90) {
      clearCube();
      mySprite.place[0] = 3;
    }
    if (x > 105) {
      clearCube();
      mySprite.place[0] = 2;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[0] = 1;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[0] = 0;
    }
    mySprite.rollX(0);
    delay(20);
  }
  mySprite.clearIt();
  for (int x = 0; x < 126; x++) {
    if (x > 15) {
      clearCube();
      mySprite.place[1] = 0;
    }
    if (x > 30) {
      clearCube();
      mySprite.place[1] = 1;
    }
    if (x > 45) {
      clearCube();
      mySprite.place[1] = 2;
    }
    if (x > 60) {
      clearCube();
      mySprite.place[1] = 3;
    }
    if (x > 75) {
      clearCube();
      mySprite.place[1] = 4;
    }
    if (x > 90) {
      clearCube();
      mySprite.place[1] = 3;
    }
    if (x > 105) {
      clearCube();
      mySprite.place[1] = 2;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[1] = 1;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[1] = 0;
    }
    mySprite.rollY(0);
    delay(20);
  }
  clearCube();
  for (int x = 0; x < 131; x++) {
    if (x > 15) {
      clearCube();
      mySprite.place[2] = 0;
    }
    if (x > 30) {
      clearCube();
      mySprite.place[2] = 1;
    }
    if (x > 45) {
      clearCube();
      mySprite.place[2] = 2;
    }
    if (x > 60) {
      clearCube();
      mySprite.place[2] = 3;
    }
    if (x > 75) {
      clearCube();
      mySprite.place[2] = 4;
    }
    if (x > 90) {
      clearCube();
      mySprite.place[2] = 3;
    }
    if (x > 105) {
      clearCube();
      mySprite.place[2] = 2;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[2] = 1;
    }
    if (x > 120) {
      clearCube();
      mySprite.place[2] = 0;
    }
    mySprite.rollZ(0);
    delay(20);
  }
  pause();
}
// ***************************** End of Rolling Ball ******************************************
// ***************************** Start of Sparkles ******************************************
// very simple animation - three LEDs in the cube are lit at random, when a 4th is lit, the 1st one is turned off
// then a 5th is lit and the 2nd one goes off, etc. etc.
void sparkles() {
  for (int j = 0; j < 125; j++) { // go around 75 times
    int newx1, newy1, newz1, newx2, newy2, newz2, newx3, newy3, newz3; // locations for 3 LEDs that are on at one time
    newx1 = random(8);
    newy1 = random(8);
    newz1 = random(8);
    ledOn(newx1, newy1, newz1); // create the first
    delay(8);
    ledOff(newx2, newy2, newz2);  // turn off the second
    newx2 = random(8);
    newy2 = random(8);
    newz2 = random(8);
    ledOn(newx2, newy2, newz2); // create the first  // create the second
    delay(8);
    ledOff(newx3, newy3, newz3);// turn off the third
    newx3 = random(8);
    newy3 = random(8);
    newz3 = random(8);
    ledOn(newx3, newy3, newz3); // create the first  // create the third
    delay(8);
    ledOff(newx1, newy1, newz1);  // turn off the first
  }
  pause();
}
// ***************************** End of Sparkles ******************************************
// ***************************** Start Warp Ribbon *****************************************
void warpRibbon() {
  int z;
  for (int j = 0; j < 6; j++) {
    for (int i = 0; i < 36; i++) { //it takes 36 steps to complete one full cycle
      for (byte xx = 0; xx < 8; xx++) {
        for (byte yy = 0; yy < 8; yy++) {
          z = ((byte)(4 + cos((xx / 7.23) + (yy / 7.23) + (float)i / 6.28) * 4)); // the  actual z calculation
          if (z > 7) {
            z = 7;
          }
          ledOn(xx, yy, z);
        }
      }
      delay(3);       // Increase or decrease to change speed of this  animation
      clearCube();    // clear the cube
    }

    for (int i = 0; i < 36; i++) { //it takes 36 steps to complete one full cycle
      for (byte xx = 0; xx < 8; xx++) {
        for (byte yy = 0; yy < 8; yy++) {
          z = ((byte)(4 + cos((xx / 7.23) + (yy / 12.23) + (float)i / 6.28) * 4)); // the  actual z calculation
          if (z > 7) {
            z = 7;
          }
          ledOn(7 - xx, yy, z);
        }
      }
      delay(3);       // Increase or decrease to change speed of this  animation
      clearCube();    // clear the cube
    }
  }
  pause();
}
// ***************************** End Warp Ribbon *****************************************
// ***************************** Start of Cube Flash ******************************************
// the cube grows and shrinks as various layers are turned on
void cubeFlash() {
  for (int mytime = 7; mytime > 0; mytime--) {
    cubeInCube(0);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(3);
    showCube(mytime * 2);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(0);
    showCube(mytime);
    clearCube();
    showCube(mytime * 2);
  }
  for (int k = 0; k < 4; k++) {
    int mytime = 1;
    cubeInCube(0);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(3);
    showCube(mytime * 2);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(0);
    showCube(mytime);
    clearCube();
    showCube(mytime * 2);
  }
  for (int mytime = 2; mytime < 8; mytime++) {
    cubeInCube(0);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(3);
    showCube(mytime * 2);
    cubeInCube(2);
    showCube(mytime);
    cubeInCube(1);
    showCube(mytime);
    cubeInCube(0);
    showCube(mytime);
    clearCube();
    showCube(mytime * 2);
  }
  pause();

}
// generate patterns from center of the cube
void cubeInCube(int k) {
  switch (k) {
    case 0:   // turn on center LED only
      for (int layer = 3; layer < 5; layer++) {
        for (int column = 3; column < 5; column++) {
          for (int row = 3; row < 5; row++) {
            ledOn(column, row, layer);
          }
        }
      }
      break;
    case 1:    // turn on all but outside layers of cube
      for (int layer = 2; layer < 6; layer++) {
        for (int column = 2; column < 6; column++) {
          for (int row = 2; row < 6; row++) {
            ledOn(column, row, layer);
          }
        }
      }
      for (int layer = 3; layer < 5; layer++) {
        for (int column = 3; column < 5; column++) {
          for (int row = 3; row < 5; row++) {
            ledOff(column, row, layer);
          }
        }
      }
      break;
    case 2:  // turn on whole cube
      for (int layer = 1; layer < 7; layer++) {
        for (int column = 1; column < 7; column++) {
          for (int row = 1; row < 7; row++) {
            ledOn(column, row, layer);
          }
        }
      }
      for (int layer = 2; layer < 6; layer++) {
        for (int column = 2; column < 6; column++) {
          for (int row = 2; row < 6; row++) {
            ledOff(column, row, layer);
          }
        }
      }
      break;
    case 3:  // turn on whole cube
      for (int layer = 0; layer < 8; layer++) {
        for (int column = 0; column < 8; column++) {
          for (int row = 0; row < 8; row++) {
            ledOn(column, row, layer);
          }
        }
      }
      for (int layer = 1; layer < 7; layer++) {
        for (int column = 1; column < 7; column++) {
          for (int row = 1; row < 7; row++) {
            ledOff(column, row, layer);
          }
        }
      }
      break;
  }
}
// ***************************** End of Cube Flash ******************************************
// ***************************** Start of Rain ******************************************
// a very simple animation - random LED are lit on top layer and fall like rain through the cube
void rainStorm() {
  for (int k = 0; k < 50; k++) {
    if (k % 2) {
      int myx = random(8);
      int myy = random(8);
      ledOn(myx, myy, 7);
    }
    delay(70);
    copyDown();
  }
  for (int k = 0; k < 50; k++) {
    int myx = random(8);
    int myy = random(8);
    ledOn(myx, myy, 7);
    myx = random(8);
    myy = random(8);
    ledOn(myx, myy, 7);
    delay(70);
    copyDown();
  }
  for (int k = 0; k < 50; k++) {
    if (k % 2) {
      int myx = random(8);
      int myy = random(8);
      ledOn(myx, myy, 7);
    }
    delay(70);
    copyDown();
  }
  pause();
}
// ***************************** End of Rain ******************************************
// ***************************** Beginning of Rotary ******************************************
// a vertical panel is spun around the center of the cube
void rotary() {
  for (int k=0; k < 3; k++) {
    for (int j = 7; j > 0; j--) {
      rotCenter(j);
    }
    for (int j = 8; j > -1; j--) {
      rotCenter(j);
    }
    for (int j = 7; j > 0; j--) {
      rotCenter(j);
    }
    for (int j = 8; j > -1; j--) {
      rotCenter(j);
    }
    for (int j = 0; j < 8; j++) {
      rotCenter(j);
    }
    for (int j = 0; j < 9; j++) {
      rotCenter(j);
    }
    for (int j = 0; j < 8; j++) {
      rotCenter(j);
    }
    for (int j = 0; j < 9; j++) {
      rotCenter(j);
    }
  }
  pause();
}

// routine that does the rotatation
void rotCenter(int k) {
  switch (k) {
    case 0:
      for (int z = 0; z < 8; z++) {
        for (int x = 0; x < 8; x++) {
          ledOn(x, x, z);
        }
      }
      break;
    case 1:
      for (int z = 0; z < 8; z++) {
        ledOn(0, 1, z);
        ledOn(1, 1, z);
        ledOn(2, 2, z);
        ledOn(3, 3, z);
        ledOn(4, 3, z);
        ledOn(5, 4, z);
        ledOn(6, 5, z);
        ledOn(7, 5, z);
      }
      break;
    case 2:
      for (int z = 0; z < 8; z++) {
        ledOn(0, 2, z);
        ledOn(1, 2, z);
        ledOn(2, 2, z);
        ledOn(3, 2, z);
        ledOn(4, 2, z);
        ledOn(5, 2, z);
        ledOn(6, 2, z);
        ledOn(7, 2, z);
      }
      break;
    case 3:
      for (int z = 0; z < 8; z++) {
        ledOn(0, 5, z);
        ledOn(1, 5, z);
        ledOn(2, 4, z);
        ledOn(3, 4, z);
        ledOn(4, 3, z);
        ledOn(5, 2, z);
        ledOn(6, 2, z);
        ledOn(7, 1, z);
      }
      break;
    case 4:
      for (int z = 0; z < 8; z++) {
        ledOn(0, 7, z);
        ledOn(1, 6, z);
        ledOn(2, 5, z);
        ledOn(3, 4, z);
        ledOn(4, 3, z);
        ledOn(5, 2, z);
        ledOn(6, 1, z);
        ledOn(7, 0, z);
      }
      break;
    case 5:
      for (int z = 0; z < 8; z++) {
        ledOn(1, 7, z);
        ledOn(1, 6, z);
        ledOn(2, 5, z);
        ledOn(3, 4, z);
        ledOn(3, 3, z);
        ledOn(4, 2, z);
        ledOn(5, 1, z);
        ledOn(5, 0, z);
      }
      break;
    case 6:
      for (int z = 0; z < 8; z++) {

        ledOn(2, 0, z);
        ledOn(2, 1, z);
        ledOn(2, 2, z);
        ledOn(2, 3, z);
        ledOn(2, 4, z);
        ledOn(2, 5, z);
        ledOn(2, 6, z);
        ledOn(2, 7, z);
      }
      break;
    case 7:
      for (int z = 0; z < 8; z++) {

        ledOn(1, 0, z);
        ledOn(2, 1, z);
        ledOn(2, 2, z);
        ledOn(3, 3, z);
        ledOn(3, 4, z);
        ledOn(4, 5, z);
        ledOn(5, 6, z);
        ledOn(5, 7, z);
      }
      break;
    case 8:
      for (int z = 0; z < 8; z++) {
        for (int x = 0; x < 8; x++) {
          ledOn(x, x, z);
        }
      }
      break;
  }
  showCube(3);
}
// ***************************** End of Rotary ******************************************
// ***************************** Begin Swings ******************************************
// This is the series of calls to the SwingAll subroutine.
void swings() {
  int myTime = 5;
  swingAll("1f", "xx", "xx", myTime);
  swingAll("4f", "xx", "xx", myTime);
  swingAll("3f", "xx", "xx", myTime);
  swingAll("2f", "xx", "xx", myTime);
  swingAll("2r", "xx", "xx", myTime);
  swingAll("3r", "xx", "xx", myTime);
  swingAll("4r", "xx", "xx", myTime);
  swingAll("1r", "xx", "xx", myTime);
  swingAll("pfy", "xx", "xx", myTime);
  swingAll("pry", "xx", "xx", myTime);
  swingAll("xx", "1f", "xx", myTime);
  swingAll("xx", "4f", "xx", myTime);
  swingAll("xx", "3f", "xx", myTime);
  swingAll("xx", "2f", "xx", myTime);
  swingAll("xx", "2r", "xx", myTime);
  swingAll("xx", "3r", "xx", myTime);
  swingAll("xx", "4r", "xx", myTime);
  swingAll("xx", "1r", "xx", myTime);
  swingAll("xx", "pfx", "xx", myTime);
  swingAll("xx", "prx", "xx", myTime);
  swingAll("xx", "xx", "1f", myTime);
  swingAll("xx", "xx", "4f", myTime);
  swingAll("xx", "xx", "3f", myTime);
  swingAll("xx", "xx", "2f", myTime);
  swingAll("xx", "xx", "2r", myTime);
  swingAll("xx", "xx", "3r", myTime);
  swingAll("xx", "xx", "4r", myTime);
  swingAll("xx", "xx", "1r", myTime);
  swingAll("xx", "xx", "pfx", myTime);
  swingAll("xx", "xx", "prx", myTime);
  swingAll("2r", "xx", "1f", myTime);
  swingAll("3r", "xx", "4f", myTime);
  swingAll("4r", "xx", "3f", myTime);
  swingAll("1r", "xx", "2f", myTime);
  swingAll("1f", "xx", "1f", myTime);
  swingAll("4f", "xx", "4f", myTime);
  swingAll("3f", "xx", "3f", myTime);
  swingAll("2f", "xx", "2f", myTime);
  swingAll("xx", "1f", "2r", myTime);
  swingAll("xx", "4f", "3r", myTime);
  swingAll("xx", "3f", "4r", myTime);
  swingAll("xx", "2f", "1r", myTime);
  swingAll("xx", "1f", "1f", myTime);
  swingAll("xx", "4f", "4f", myTime);
  swingAll("xx", "3f", "3f", myTime);
  swingAll("xx", "2f", "2f", myTime);
  swingAll("2r", "1f", "xx", myTime);
  swingAll("3r", "4f", "xx", myTime);
  swingAll("4r", "3f", "xx", myTime);
  swingAll("1r", "2f", "xx", myTime);
  swingAll("1f", "2r", "xx", myTime);
  swingAll("4f", "3r", "xx", myTime);
  swingAll("3f", "4r", "xx", myTime);
  swingAll("2f", "1r", "xx", myTime);
  swingAll("1f", "xx", "xx", myTime);
  swingAll("4f", "xx", "xx", myTime);
  swingAll("3f", "xx", "xx", myTime);
  swingAll("2f", "xx", "xx", myTime);
  swingAll("2r", "xx", "xx", myTime);
  swingAll("3r", "xx", "xx", myTime);
  swingAll("4r", "xx", "xx", myTime);
  swingAll("1r", "xx", "xx", myTime);
  swingAll("xx", "1f", "xx", myTime);
  swingAll("xx", "4f", "xx", myTime);
  swingAll("xx", "3f", "xx", myTime);
  swingAll("xx", "2f", "xx", myTime);
  swingAll("xx", "2r", "xx", myTime);
  swingAll("xx", "3r", "xx", myTime);
  swingAll("xx", "4r", "xx", myTime);
  swingAll("xx", "1r", "xx", myTime);
  swingAll("xx", "xx", "1f", myTime);
  swingAll("xx", "xx", "4f", myTime);
  swingAll("xx", "xx", "3f", myTime);
  swingAll("xx", "xx", "2f", myTime);
  swingAll("xx", "xx", "2r", myTime);
  swingAll("xx", "xx", "3r", myTime);
  swingAll("xx", "xx", "4r", myTime);
  swingAll("xx", "xx", "1r", myTime);
  pause();
}

// This is a subroutine that swings three sheets of LEDs from one face of the cube to another.  The string input
// tells the routine the corner which we are going to swing from, and direction of
// rotation.  The time input in milliseconds between steps.
// It also has some options to sent the sheet straight across the cube instead of swinging. These
// start with a p and then specify the direction and plane of movement.
void swingAll(String RedString, String GreenString, String BlueString, int myTime) {

  for (int i = 0; i < 8; i++) {
    for (int z = 0; z < 8; z++) {
      for (int x = 0; x < 8; x++) {
        // do it all around the z axis
        if (BlueString == "1r") {
          ledOn(x, diagonal[x][i], z);
        }
        else if (BlueString == "1f") {
          ledOn(diagonal[7 - x][i], 7 - x, z);
        }
        else if (BlueString == "2f") {
          ledOn(x, 7 - diagonal[x][i], z);
        }
        else if (BlueString == "2r") {
          ledOn(diagonal[7 - x][i], x, z);
        }
        else if (BlueString == "3r") {
          ledOn(7 - x, 7 - diagonal[x][i], z);
        }
        else if (BlueString == "3f") {
          ledOn(7 - diagonal[7 - x][i], x, z);
        }
        else if (BlueString == "4f") {
          ledOn(7 - x, diagonal[x][i], z);
        }
        else if (BlueString == "4r") {
          ledOn(7 - diagonal[7 - x][i], 7 - x, z);
        }
        else if (BlueString == "pfy") {
          ledOn(x, i / 2, z);
        }
        else if (BlueString == "pry") {
          ledOn(x, 7 - (i / 2), z);
        }
        else if (BlueString == "pfx") {
          ledOn(i / 2, x, z);
        }
        else if (BlueString == "prx") {
          ledOn(7 - (i / 2), x, z);
        }
        // now do it all again around the x axis
        if (RedString == "1r") {
          ledOn(z, x, diagonal[x][i]);
        }
        else if (RedString == "1f") {
          ledOn(z, diagonal[7 - x][i], 7 - x);
        }
        else if (RedString == "2f") {
          ledOn(z, x, 7 - diagonal[x][i]);
        }
        else if (RedString == "2r") {
          ledOn(z, diagonal[7 - x][i], x);
        }
        else if (RedString == "3r") {
          ledOn(z, 7 - x, 7 - diagonal[x][i]);
        }
        else if (RedString == "3f") {
          ledOn(z, 7 - diagonal[7 - x][i], x);
        }
        else if (RedString == "4f") {
          ledOn(z, 7 - x, diagonal[x][i]);
        }
        else if (RedString == "4r") {
          ledOn(z, 7 - diagonal[7 - x][i], 7 - x);
        }
        else if (RedString == "pfy") {
          ledOn(x, i / 2, z);
        }
        else if (RedString == "pry") {
          ledOn(x, 7 - (i / 2), z);
        }
        else if (RedString == "pfz") {
          ledOn(x, z, i / 2);
        }
        else if (RedString == "prz") {
          ledOn(x, z, 7 - (i / 2));
        }
        // now do it all again around the y axis
        if (GreenString == "1r") {
          ledOn(x, z, diagonal[x][i]);
        }
        else if (GreenString == "1f") {
          ledOn(diagonal[7 - x][i], z, 7 - x);
        }
        else if (GreenString == "2f") {
          ledOn(x, z, 7 - diagonal[x][i]);
        }
        else if (GreenString == "2r") {
          ledOn(diagonal[7 - x][i], z, x);
        }
        else if (GreenString == "3r") {
          ledOn(7 - x, z, 7 - diagonal[x][i]);
        }
        else if (GreenString == "3f") {
          ledOn(7 - diagonal[7 - x][i], z, x);
        }
        else if (GreenString == "4f") {
          ledOn(7 - x, z, diagonal[x][i]);
        }
        else if (GreenString == "4r") {
          ledOn(7 - diagonal[7 - x][i], z, 7 - x);
        }
        else if (GreenString == "pfx") {
          ledOn(i / 2, x, z);
        }
        else if (GreenString == "prx") {
          ledOn(7 - (i / 2), x, z);
        }
        else if (GreenString == "pfz") {
          ledOn(x, z, i / 2);
        }
        else if (GreenString == "prz") {
          ledOn(x, z, 7 - (i / 2));
        }
      }
    }
    delay(myTime);
    clearCube();
  }

  for (int i = 6; i > -1; i--) {
    for (int z = 0; z < 8; z++) {
      for (int x = 0; x < 8; x++) {
        // do it all around the z axis
        if (BlueString == "1r") {
          ledOn(diagonal[x][i], x, z);
        }
        else if (BlueString == "1f") {
          ledOn(7 - x, diagonal[7 - x][i], z);
        }
        else  if (BlueString == "2f") {
          ledOn(diagonal[x][i], 7 - x, z);
        }
        else  if (BlueString == "2r") {
          ledOn(7 - x, 7 - diagonal[7 - x][i], z);
        }
        else if (BlueString == "3r") {
          ledOn(7 - diagonal[x][i], 7 - x, z);
        }
        else if (BlueString == "3f") {
          ledOn(x, 7 - diagonal[7 - x][i], z);
        }
        else if (BlueString == "4f") {
          ledOn(7 - diagonal[x][i], x, z);
        }
        else if (BlueString == "4r") {
          ledOn(x, diagonal[7 - x][i], z);
        }
        else if (BlueString == "pfy") {
          ledOn(x, 3 + (7 - i) / 2, z);
        }
        else if (BlueString == "pry") {
          ledOn(x, 4 - (7 - i) / 2, z);
        }
        else if (BlueString == "pfx") {
          ledOn(3 + (7 - i) / 2, x, z);
        }
        else if (BlueString == "prx") {
          ledOn(4 - (7 - i) / 2, x, z);
        }
        // now do it all again around the x axis
        if (RedString == "1r") {
          ledOn(z, diagonal[x][i], x);
        }
        else if (RedString == "1f") {
          ledOn(z, 7 - x, diagonal[7 - x][i]);
        }
        else if (RedString == "2f") {
          ledOn(z, diagonal[x][i], 7 - x);
        }
        else if (RedString == "2r") {
          ledOn(z, 7 - x, 7 - diagonal[7 - x][i]);
        }
        else if (RedString == "3r") {
          ledOn(z, 7 - diagonal[x][i], 7 - x);
        }
        else if (RedString == "3f") {
          ledOn(z, x, 7 - diagonal[7 - x][i]);
        }
        else if (RedString == "4f") {
          ledOn(z, 7 - diagonal[x][i], x);
        }
        else if (RedString == "4r") {
          ledOn(z, x, diagonal[7 - x][i]);
        }
        else if (RedString == "pfy") {
          ledOn(x, 3 + (7 - i) / 2, z);
        }
        else if (RedString == "pry") {
          ledOn(x, 4 - (7 - i) / 2, z);
        }
        else if (RedString == "pfz") {
          ledOn(x, z, 3 + (7 - i) / 2);
        }
        else if (RedString == "prz") {
          ledOn(x, z, 4 - (7 - i) / 2);
        }

        // now do it all again around the y axis
        if (GreenString == "1r") {
          ledOn(diagonal[x][i], z, x);
        }
        else if (GreenString == "1f") {
          ledOn(7 - x, z, diagonal[7 - x][i]);
        }
        else if (GreenString == "2f") {
          ledOn(diagonal[x][i], z, 7 - x);
        }
        else if (GreenString == "2r") {
          ledOn(7 - x, z, 7 - diagonal[7 - x][i]);
        }
        else if (GreenString == "3r") {
          ledOn(7 - diagonal[x][i], z, 7 - x);
        }
        else if (GreenString == "3f") {
          ledOn(x, z, 7 - diagonal[7 - x][i]);
        }
        else if (GreenString == "4f") {
          ledOn(7 - diagonal[x][i], z, x);
        }
        else if (GreenString == "4r") {
          ledOn(x, z, diagonal[7 - x][i]);
        }
        else if (GreenString == "pfx") {
          ledOn(3 + (7 - i) / 2, x, z);
        }
        else if (GreenString == "prx") {
          ledOn(4 - (7 - i) / 2, x, z);
        }
        else if (GreenString == "pfz") {
          ledOn(x, z, 3 + (7 - i) / 2);
        }
        else if (GreenString == "prz") {
          ledOn(x, z, 4 - (7 - i) / 2);
        }
      }
    }

    delay(myTime);
    clearCube();
  }
}
// ***************************** End Swings ******************************************
// ***************************** Begin Diamond Wave ******************************************
void diamondWave() {
  int z, z1;
  for (int j = 0; j < 15; j++) { // go up and down 15 times
    for (int i = 0; i < 18; i++) { // moving upward
      for (byte xx = 0; xx < 8; xx++) { // Here we generate both the upper and  lower pyramid
        for (byte yy = 0; yy < 8; yy++) { // If actually starts out as a cone, but  flairs out to a square at its widest.
          z = int(i - 9.5 + distance[xx][yy]);
          z1 = int(i - 0.5 - distance[xx][yy]);
          if (z > -1 && z < 8) {
            ledOn(xx, yy, z);
          }
          if (z1 > -1 && z1 < 8) {
            ledOn(xx, yy, z1);
          }
        }
      }
      delay(20);       // Increase or decrease to change speed of this  animation
      clearCube();    // clear the cube
    }
    for (int i = 16; i > 0; i--) { //moving downward

      for (byte xx = 0; xx < 8; xx++) { //
        for (byte yy = 0; yy < 8; yy++) {
          z = int(i - 9.5 + distance[xx][yy]);
          z1 = int(i - 0.5 - distance[xx][yy]);
          if (z > -1 && z < 8) {
            ledOn(xx, yy, z);
          }
          if (z1 > -1 && z1 < 8) {
            ledOn(xx, yy, z1);
          }
        }
      }
      delay(20);       // Increase or decrease to change speed of this  animation
      clearCube();    // clear the cube
    }
  }
  pause();
}
// ***************************** End Diamond Wave ******************************************
// ***************************** Begin Dancing Fireflys ******************************************
// we are moving a falling column around at random from the top of the cube.
void dancingFireflys() {
  int xpos = 4;
  int ypos = 4;
  int myrandom, count;
  for (int k = 0; k < 500; k++) {
    count++;
    myrandom = random(5);
    if (myrandom == 0) {
      xpos++;
    }
    if (myrandom == 1) {
      xpos--;
    }
    if (myrandom == 2) {
      ypos++;
    }
    if (myrandom == 3) {
      ypos--;
    }
    if (xpos < 0) {
      xpos = 1;
    }
    if (xpos > 7) {
      xpos = 6;
    }
    if (ypos < 0) {
      ypos = 1;
    }
    if (ypos > 7) {
      ypos = 6;
    }
    ledOn(xpos, ypos, 7);
    if (count % 2) copyDown();
    delay(15);
  }
  pause();
}
// ***************************** End Dancing Fireflys ******************************************
// ***************************** Beginning of Panels ******************************************
// the most basic of cube animations. An entire panel in x, y, z direction is turned on
// and then moved through the cube.
void panels() {
  for (int k = 0; k < 6; k++) {
    for (int z = 7; z > -1; z--) {
      for (int x = 0; x < 8; x++) {
        for (int y = 0; y < 8; y++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int z = 0; z < 8; z++) {
      for (int x = 0; x < 8; x++) {
        for (int y = 0; y < 8; y++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int x = 0; x < 8; x++) {
      for (int z = 0; z < 8; z++) {
        for (int y = 0; y < 8; y++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int x = 7; x > -1; x--) {
      for (int z = 0; z < 8; z++) {
        for (int y = 0; y < 8; y++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int y = 0; y < 8; y++) {
      for (int x = 0; x < 8; x++) {
        for (int z = 0; z < 8; z++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
    for (int y = 7; y > -1; y--) {
      for (int x = 0; x < 8; x++) {
        for (int z = 0; z < 8; z++) {
          ledOn(x, y, z);
        }
      }
      showCube(3);
    }
  }
  pause();
}

// ***************************** End of Panels ******************************************
// ***************************** Start of Sphere ******************************************

void sphere() {
  float polar, x, y, z;
  byte cube [8][8][8]; // used by some animations
  for (byte layer = 0; layer < 8; layer++) { // scan thru each layer
    for (byte column = 0; column < 8; column++) { // scan thru every column
      for (byte panel = 0; panel < 8; panel++) { // scan thru every panel
        x = float(layer); // convert coordinates to floating point to compute distance from center of cube
        y = float(panel);
        z = float(column);
        cube[column][panel][layer] = 5 * sqrt((x - 3.5) * (x - 3.5) + (y - 3.5) * (y - 3.5) + (z - 3.5) * (z - 3.5)); // Calculate the distance
      }
    }
  }
  for (int counter = 0; counter < 20; counter++) {
    for ( int count = 0; count < 20; count++) { //expand
      for (byte layer = 0; layer < 8; layer++) { // scan thru each layer
        for (byte column = 0; column < 8; column++) { // scan thru every column
          for (byte panel = 0; panel < 8; panel++) { // scan thru every panel
            if (cube[column][panel][layer] < count) { // if an LED is inside the radius specified by count, turn it on.
              ledOn(column, panel, layer);
            }
            else { // otherwise turn it off
              ledOff(column, panel, layer);
            }
          }
        }
      }
      delay(5);
    }
    for (int count = 19; count > 0; count--) { //contract
      for (byte layer = 0; layer < 8; layer++) { // scan thru each layer
        for (byte column = 0; column < 8; column++) { // scan thru every column
          for (byte panel = 0; panel < 8; panel++) { // scan thru every panel
            if (cube[column][panel][layer] < count) { // if an LED is inside the radius specified by count, turn it on.
              ledOn(column, panel, layer);
            }
            else { // otherwise turn it off
              ledOff(column, panel, layer);
            }
          }
        }
      }
      delay(5);
    }
  }
  pause();
}
// ***************************** End of Sphere ******************************************
// ***************************** Start of Sinewave ******************************************
void sineWave() {
  byte z;
  float pi = 3.14159;
  for (int j = 0; j < 15; j++) {
    for (int i = 0; i < 40; i++) { //it takes 40 steps to complete one full cycle
      for (byte xx = 0; xx < 4; xx++) { // for 1 quadrant of the cube
        for (byte yy = 0; yy < 4; yy++) {
          // the next line is the guts of the calculation, where the z value is calculated both as a function of i and distance
          // from center of cube.  The calculation is time consuming, so we calculate it for only one quadrant and
          // then reflect it onto the other 3 quadrants.
          z = ((byte)((4 + sin(sqrt((3.5 - xx) * (3.5 - xx) + (3.5 - yy) * (3.5 - yy)) / 1.57 + (float)i / 6.28) * 4))); // the actual z calculation
          // 1.57 = max dist from center / pi   and 6.28 is 2*pi; 1st 4 centers in cube, 2nd 4 scales the sine
          ledOn(xx, yy, z); // put z into the proper place for each position in quadrant 1
          ledOn(7 - xx, 7 - yy, z); // put z into the proper place for each position in quatrant 3
          ledOn(7 - xx, yy, z); // put z into the proper place for each position in quatrant 2
          ledOn(xx, 7 - yy, z); // put z into the proper place for each position in quatrant 4
        }
      }
      delay(5);
      clearCube();    // clear the cube
    }
  }
  pause();
}
// ***************************** End of Sinewave ******************************************

// an animation using the sprite object class
void Multi_Swirl() {
   sprite LED1(2,2,2);  //create 6 sprites
  LED1.fillIt();
  LED1.assignplace(5,4,3);
  LED1.assignmotion(1,-2,1);

  sprite LED2(2,2,2);
  LED2.fillIt();
  LED2.assignplace(3,4,5);
  LED2.assignmotion(2,1,-2);
  
  sprite LED3(2,2,2);
  LED3.fillIt();
  LED3.assignplace(2,6,3);
  LED3.assignmotion(1,-1,-1);
   
  sprite LED4(2,2,2);
  LED4.fillIt();
  LED4.assignplace(5,1,2);
  LED4.assignmotion(2,1,-1);
 
  sprite LED5(2,2,2);
  LED5.fillIt();
  LED5.assignplace(1,2,3);
  LED5.assignmotion(1,1,2);

  sprite LED6(2,2,2);
  LED6.fillIt();
  LED6.assignplace(5,1,2);
  LED6.assignmotion(2,1,-1);

  for (int count=0; count<150; count++) {  //now bounce all these sprites  around in the cube
    LED1.bounceIt();
    LED2.bounceIt();
    LED3.bounceIt();
    LED4.bounceIt();
    LED5.bounceIt();
    LED6.bounceIt();
    delay(60); // delay 125msec between each movement. 
  }
  LED1.clearIt();
  LED2.clearIt();
  LED3.clearIt();
  LED4.clearIt();
  LED5.clearIt();
  LED6.clearIt();
}

// This animation uses the sprite classes wireframe action
  void corners(){
  int mytime = 20;
  for (int k = 0; k < 4; k++) {
    for (int j = 1; j < 7; j++) {
      sprite mySprite1(j, j, j);
      mySprite1.wireframe();
      mySprite1.assignplace(0, 0, 0);
      mySprite1.setIt();
      delay(mytime);
      clearCube();
    }
    for (int j = 6; j > 0; j--) {
      sprite mySprite1(j, j, j);
      mySprite1.wireframe();
      mySprite1.assignplace(0, 0, 0);
      mySprite1.setIt();
      delay(mytime);
      clearCube();
    }
    for (int j = 1; j < 7; j++) {
      sprite mySprite1(j, j, j);
      mySprite1.wireframe();
      mySprite1.assignplace(8 - j, 8 - j, 8 - j);
      mySprite1.setIt();
      delay(mytime);
      clearCube();
    }
    for (int j = 6; j > 0; j--) {
      sprite mySprite1(j, j, j);
      mySprite1.wireframe();
      mySprite1.assignplace(8 - j, 8 - j, 8 - j);
      mySprite1.setIt();
      delay(mytime);
      clearCube();
    }
    for (int j = 1; j < 7; j++) {
      sprite mySprite1(j, j, j);
      mySprite1.wireframe();
      mySprite1.assignplace(8 - j,  0, 0);
      mySprite1.setIt();
      delay(mytime);
      clearCube();
    }
    for (int j = 6; j > 0; j--) {
      sprite mySprite1(j, j, j);
      mySprite1.wireframe();
      mySprite1.assignplace(8 - j,  0, 0);
      mySprite1.setIt();
      delay(mytime);
      clearCube();
    }
    for (int j = 1; j < 7; j++) {
      sprite mySprite1(j, j, j);
      mySprite1.wireframe();
      mySprite1.assignplace(0 , 8 - j, 8 - j);
      mySprite1.setIt();
      delay(mytime);
      clearCube();
    }
    for (int j = 6; j > 0; j--) {
      sprite mySprite1(j, j, j);
      mySprite1.wireframe();
      mySprite1.assignplace(0 , 8 - j, 8 - j);
      mySprite1.setIt();
      delay(mytime);
      clearCube();
    }
  }
}
// This is another animation based on ths sprite object class
void boxes() {
  sprite mySprite1(4, 4, 4);
  mySprite1.wireframe();
  mySprite1.assignplace(0, 0, 0);
  mySprite1.setIt();

  sprite mySprite2(4, 4, 4);
  mySprite2.wireframe();
  mySprite2.assignplace(0, 4, 4);
  mySprite2.setIt();

  sprite mySprite3(4, 4, 4);
  mySprite3.wireframe();
  mySprite3.assignplace(3, 3, 0);
  mySprite3.setIt();

  for (int j = 0; j < 120; j++) {
    mySprite1.rollZ(0);
    mySprite2.rollX(0);
    mySprite3.rollY(0);
    delay(30);
  }
}

// the next 8 animations make use of the rotation routines. Patterns are created in the buffer_cube
// array and rotated in the actual cube.
void Hula() {
  rotation = 20 * .0174532; // convert 10 degree angle to radians
  for (int reps = 0; reps < 25; reps++) {
    for (int z = 0; z < 8; z++) { // for each layer
      // here is the actual animation for one layer and it's compliment (7-z)
      for (int x = 0; x < z + 1; x++) {
        for (int y = 0; y < z + 1; y++) {
          buffer_LEDon(x, y, 7 - z);
        }
      }
      for (int x = 0; x < z + 1; x++) {
        for (int y = 0; y < z + 1; y++) {
          buffer_LEDon(x, y, z);
        }
      }
      for (int x = 1; x < z; x++) {
        for (int y = 1; y < z; y++) {
          buffer_LEDoff(x, y, 7 - z);
        }
      }
      for (int x = 1; x < z; x++) {
        for (int y = 1; y < z; y++) {
          buffer_LEDoff(x, y, z);
        }
      }
    }
    // Now we rotate the new formation 90 degrees. (9 * 10 degrees)
    for (int count = 0; count < 9; count++) { // now rotate it.
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle > 6.28318) { // and make sure it doesn't overflow
        myangle = myangle - 6.28318; //subtract 2 pi radians
      }
    }
  }

}

void saddle2() {
  float myZ;
  int z;
  for (byte x = 0; x < 8; x++) {
    for (byte y = 0; y < 8; y++)
    { // scan thru every y
      myZ = (x - 3.5) * (x - 3.5) - (y - 3.5) * (y - 3.5);
      z = 3.5 + (myZ) / (3);
      buffer_LEDon(x, y, z);
    }
  }  // x and y
  rotateCube(3, -30);
  rotateCube(3, 30);
  rotateCube(3, -30);
  rotateCube(3, 30);
}

void angled() {
  //tmpfill(0x00);
  for (unsigned char  z = 0; z < 8; z++)
    for (unsigned char  x = 0; x < 8; x++)
      for (unsigned char  y = 0; y < 8; y++)
        if (x + y == 2 * z)
          buffer_LEDon(x, y, z);
  rotateCube(10, 40);
}
void rotatingSprites() {
  sprite mySprite(2, 2, 2);
  mySprite.assignplace(1, 1, 0);
  mySprite.fillIt();
  mySprite.setIt();

  sprite mySprite2(2, 2, 2);
  mySprite2.assignplace(6, 3, 2);
  mySprite2.fillIt();
  mySprite2.setIt();

  sprite mySprite3(2, 2, 2);
  mySprite3.assignplace(3, 6, 4);
  mySprite3.fillIt();
  mySprite3.setIt();

  for (int z = 0; z < 8; z++) {
    for (int x = 0; x < 8; x++) {
      for (int y = 0; y < 8; y++) {
        if (ledStatus(x, y, z)) buffer_cube[x][y][z] = 1;
      }
    }
  }
  mySprite.clearIt();
  rotation = 50 * .0174532; // convert angle to radians
  for (int count = 0; count < 60; count++) { // now rotate it.
    rotateAll(myangle);  // the actual rotation of the animation
    myangle = myangle - rotation; // increment the angle
    if (myangle < 0) { // and make sure it doesn't overflow
      myangle = myangle + 6.28318; //add 2 pi radians
    }
  }
  clearBufferCube();
  pause();
}

// this animation turns random LEDs on while rotating them around in the cube
// after a while we change the color and then change it again.

void randomRotation(int myspeed) {
  rotation = myspeed * .0174532; // convert angle to radians
  for (int reps = 0; reps < 20; reps++) {
    buffer_LEDon(1 + random(6), 1 + random(6), random(8)); // this is the LED we light
    // we don't light the outside  corners of the cube because they will disappear as they are rotated
    buffer_cube[random(8)][random(8)][random(8)] = 0; // we turn off 5 LEDs at random for every one we
    buffer_cube[random(8)][random(8)][random(8)] = 0;  // turn on, so that we never have more than 20
    buffer_cube[random(8)][random(8)][random(8)] = 0;  // of the LEDs lit at any time
    buffer_cube[random(8)][random(8)][random(8)] = 0;
    buffer_cube[random(8)][random(8)][random(8)] = 0;
    for (int count = 0; count < 11; count++) { // now rotate the whole thing
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle > 6.28318) { // and make sure it doesn't overflow
        myangle = myangle - 6.28318;
      }
    }
  }
  clearBufferCube();
  pause();
}



// This makes a donut revolve in the middle of the cube.
void donut(int mycount) {
  for (int reps = 0; reps < mycount; reps++) {
    rotation = 30 * .0174532; // convert angle to radians
    for (int layer = 0;  layer < 8; layer++) { // build the donut on the buffer_cube array.
      for  (int panel = 0; panel < 8; panel++) {
        float mydistance = distance[layer][panel];
        if (mydistance < 4) { // make a circle 2 columns wide
          buffer_LEDon(3, panel, layer);
          buffer_LEDon(4, panel, layer);
        }
        if (mydistance < 2) { // make the donut hole
          buffer_cube[3][ panel][layer] = 0;
          buffer_cube[4][ panel][layer] = 0;
        }
      }
    }
    for (int count = 0; count < 5; count++) { // now rotate it.
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle > 6.28318) { // and make sure it doesn't overflow
        myangle = myangle - 6.28318; //subtract 2 pi radians
      }
    }
  }
  clearBufferCube();
  pause();
}

void rotor(int reps, int myspeed) {
  rotation = myspeed * .0174532; // convert angle to radians
  for (int mycount = 0; mycount < reps; mycount++) { // create the first pattern
    for (byte layer = 0; layer < 8; layer++) {
      buffer_LEDon(7, 7 - layer, layer);
      buffer_LEDon(6, 7 - layer, layer);
      buffer_LEDon(1, layer, layer);
      buffer_LEDon(0, layer, layer);
    }
    for (int count = 0; count < 30; count++) { // rotate it
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle > 6.28318) { // and make sure it doesn't overflow
        myangle = myangle - 6.28318;
      }
    }
    clearBufferCube();
    for (byte layer = 0; layer < 8; layer++) { // create the second pattern
      buffer_LEDon(6, 7 - layer, layer);
      buffer_LEDon(5, 7 - layer, layer);
      buffer_LEDon(2, layer, layer);
      buffer_LEDon(1, layer, layer);
    }
    for (int count = 0; count < 30; count++) { // rotate it
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle > 6.28318) { // and make sure it doesn't overflow
        myangle = myangle - 6.28318;
      }
    }
    clearBufferCube();

    for (byte layer = 0; layer < 8; layer++) { // create the third pattern
      buffer_LEDon(5, 7 - layer, layer);
      buffer_LEDon(4, 7 - layer, layer);
      buffer_LEDon(3, layer, layer);
      buffer_LEDon(2, layer, layer);
    }
    for (int count = 0; count < 30; count++) { // rotate it
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle > 6.28318) { // and make sure it doesn't overflow
        myangle = myangle - 6.28318; //subtract 2 pi radians
      }
    }
    rotation = -rotation;
    for (int count = 0; count < 30; count++) { // now rotate the third pattern backward
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle <= 0) { // don't let angle overflow
        myangle = myangle + 6.28318;
      }
    }
    clearBufferCube(); // reload the 2nd pattern
    for (byte layer = 0; layer < 8; layer++) {
      buffer_LEDon(6, 7 - layer, layer);
      buffer_LEDon(5, 7 - layer, layer);
      buffer_LEDon(2, layer, layer);
      buffer_LEDon(1, layer, layer);
    }
    for (int count = 0; count < 30; count++) { // rotate it backward
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle <= 0) { // don't let angle overflow
        myangle = myangle + 6.28318;
      }
    }
    clearBufferCube();
    for (byte layer = 0; layer < 8; layer++) { // reload the first pattern
      buffer_LEDon(7, 7 - layer, layer);
      buffer_LEDon(6, 7 - layer, layer);
      buffer_LEDon(1, layer, layer);
      buffer_LEDon(0, layer, layer);
    }
    for (int count = 0; count < 30; count++) { // rotate it backward
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle <= 0) { // don't let angle overflow
        myangle = myangle + 6.28318;
      }
    }
    for (byte layer = 0; layer < 8; layer++) { // now add a reversed version of the first pattern
      buffer_LEDon(7, layer, layer); // we didn't clear the buffer so both patterns are there together
      buffer_LEDon(6, layer, layer);
      buffer_LEDon(1, 7 - layer, layer);
      buffer_LEDon(0, 7 - layer, layer);
    }
    for (int count = 0; count < 30; count++) { // not rotate it forward
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle <= 0) { // don't let angle overflow
        myangle = myangle + 6.28318;
      }
    }
    rotation = -rotation;
    for (int count = 0; count < 30; count++) { // and rotate it backwards
      rotateAll(myangle);  // the actual rotation of the animation
      myangle = myangle + rotation; // increment the angle
      if (myangle > 6.28318) { // and make sure it doesn't overflow
        myangle = myangle - 6.28318;
      }
    }
  }
  clearBufferCube();
  pause();
}

/*  Atom is my version of Nick Schulze's Atom animation.  There are a lot of things
  going on here.  The animation operates in a small set of only 20 columns, represented by
  atomTable.  We basically operate around these 20 columns using index i. We step
  through the animation with index k, first with k increasing and then with k decreasing.
  More positions are lit as k increases. The real action is in which layer each of Atom's
  columns is lit up. There is a linear vertical component called p which varies between
  0 and 3, and sinewave component controlled by both j(the offset of i) and k.  Together
  j and k give us a double sinewave that slowly precesses around the cube.
*/

// This is the main Atom routine
//*******************************Note this uses sin()*********************
void atom() {
  int j, p = 1, up_down;
  int mySpeed = 15;

  for (unsigned char  k = 0; k < 20; k++) { // at first k is increassing
    if (up_down == 0) { // up_down controls the direction of the linear vertical offset
      p++;
    }
    else {
      p--;
    }
    if (p < 1) {
      up_down = 0;
    }
    if (p > 2) {
      up_down = 1;
    }

    for (int i = 0; i < 20; i++) { // i steps us through the 20 columns being used
      j = i; // j is the offset of i for the different lit positions, starting with 0 offset.
      if (j > 19) {
        j = j - 20;
      }

      // the next line is where the first atom shown gets its position
      ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      if (k > 3) { // if k is >3, then the 2nd atom is shown
        j = i - 3;
        if (j < 0) {
          j = j + 20;
        }

        // the next line is where the 2nd atom shown gets its position
        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
 
      }
      if (k > 6) {
        j = i - 6;
        if (j < 0) {
          j = j + 20;
        }

       ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      }
      if (k > 9) {
        j = i - 9;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));

      }
      if (k > 12) {
        j = i - 12;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));

      }
      if (k > 15) {
        j = i - 15;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
     
      }
      if (k > 18) {
        j = i - 18;
        if (j < 0) {
          j = j + 20;
        }

       ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      }
      delay(mySpeed);
      clearCube();  //clears the cube, but only the columns being used.
    }
  }
  for (signed char  k = 18; k > 0; k--) { // Now we do it all over again with k declining
    if (up_down == 0) {
      p++;
    }
    else {
      p--;
    }
    if (p < 1) {
      up_down = 0;
    }
    if (p > 2) {
      up_down = 1;
    }
    for (int i = 0; i < 20; i++) {
      j = i;
      if (j > 19) {
        j = j - 20;
      }

      ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      if (k > 3) {
        j = i - 3;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      }
      if (k > 6) {
        j = i - 6;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      }
      if (k > 9) {
        j = i - 9;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      }
      if (k > 12) {
        j = i - 12;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      }
      if (k > 15) {
        j = i - 15;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      }
      if (k > 18) {
        j = i - 18;
        if (j < 0) {
          j = j + 20;
        }

        ledOn(atomTable[j][0], atomTable[j][1], 2 + p + int(3 * sin(((j - k) * 12.56) / 20)));
      }
     delay(mySpeed);
      clearAtom();
    }
  }
}


// This little routine clears the cube, but for speed,
// it only operates onperates on the specific columns used by Atom
void clearAtom() {
  for (int j = 0; j < 20; j++)
    for (unsigned char layer = 0; layer < 8; layer++)
      ledOff(atomTable[j][0], atomTable[j][1], layer);
}





void elevators() {
  char location[8][8][2];  //this array stores the location and direction of  each elevator
  for (int xx = 0; xx < 8; xx++) // this is the setup routine.
    for (int yy = 0; yy < 8; yy++)
    {
      location[xx][yy][0] = rand() % 4; // pick an initial floor
      if (location[xx][yy][0] > 0) {
        location[xx][yy][0] = 10; // only ones on  the ground floor are chosen.
      }
      // other 2/4 of LEDs are banished to the 10th floor where they won't be  seen.
      location[xx][yy][1] = rand() % 3; // select an initial direction of  travel: up, down, or stopped.
      if (location[xx][yy][0] < 8)  // if it's not on the 10th floor,
        ledOn(xx, yy, location[xx][yy][0]); // turn it  on.
    }
  delay(600); // our elevators are all set up and lit up on the ground floor.
  for (int j = 0;  j < 150; j++) { // now we put them in motion
    for (int xx = 0; xx < 8; xx++) {
      for (int yy = 0; yy < 8; yy++) {
        if (location[xx][yy][0] < 8)
        { // if it's a valid elevator
          ledOff(xx, yy, location[xx][yy][0]);          // then erase it from its  current position
          if (rand() % 3 == 0)                            // 1/3 of the time
            location[xx][yy][1] = rand() % 3;            //change direction: up, down, or  stopped

          if (location[xx][yy][1] == 1)
          { // if it's going up,
            if (location[xx][yy][0] < 7)                  // and not already on the top floor
              location[xx][yy][0] = location[xx][yy][0] + 1; // move it up one
            else
            { // on the top floor?
              location[xx][yy][0] = location[xx][yy][0] - 1; // move down one
              location[xx][yy][1] = 2;                   // change direction to down
            }
          } // if location 1 == 1

          if (location[xx][yy][1] == 2)
          { // if it's going down,
            if (location[xx][yy][0] > 0)
            { // and not already on the ground floor
              location[xx][yy][0] = location[xx][yy][0] - 1; // move it down one
            }
            else
            { // on the bottom floor?
              location[xx][yy][0] = location[xx][yy][0] + 1; // move up one
              location[xx][yy][1] = 1; //change direction to up
            }
          } // location 1 ==2

          ledOn(xx, yy, location[xx][yy][0]);           // turn on  in new location
        } //location <8
      } // yy
    }  //xx
    delay(50);  // wait, with animation speeding up as j increases.
  }
}

/* Angled2 is another diagonal plane animaiton.  Variations include
  multiple planes and different colors.
*/

void angled2() {
  int mydelay = 40;
  for (unsigned char j = 0; j < 39; j++) {
    angledx(j);
    delay(mydelay);
    clearCube();
    angledy(j);
    delay(mydelay);
    clearCube();
    angledz(j);
    delay(mydelay);
    clearCube();
  }
}

void angledx(int mycount) {
  for (unsigned char  z = 0; z < 8; z++)
    for (unsigned char  x = 0; x < 8; x++)
      for (unsigned char  y = 0; y < 8; y++)
        if (x + y == 2 * z)
          if (mycount < 20)
            ledOn(x, y, z);
          else
            ledOn(x, y, 7 - z);
}

void angledy(int mycount) {
  for (unsigned char  z = 0; z < 8; z++)
    for (unsigned char  x = 0; x < 8; x++)
      for (unsigned char  y = 0; y < 8; y++)
        if (x + y == 2 * z)
          if (mycount < 20)
            ledOn(y, z, x);
          else
            ledOn(y, z, 7 - x);
}

void angledz(int mycount) {
  for (unsigned char  z = 0; z < 8; z++)
    for (unsigned char  x = 0; x < 8; x++)
      for (unsigned char  y = 0; y < 8; y++)
        if (x + y == 2 * z)
          if (mycount < 20)
            ledOn(z, x, y);
          else
            ledOn(z, x, 7 - y);
}


void show_sphere3(int radius) { // draw the sphere
  float polar;
  for (unsigned char  layer = 0; layer < 8; layer++) // scan thru each layer
    for (byte column = 0; column < 8; column++) // scan thru every column
      for (byte panel = 0; panel < 8; panel++)
      { // scan thru every panel
        polar = (layer - 3.5) * (layer - 3.5) + (panel - 3.5) * (panel - 3.5) + (column - 3.5) * (column - 3.5); // Calculate the distance squared
        if (polar < radius * radius) // if an LED is inside the radius specified by radius, turn it on.
          ledOn(column, panel, layer);
      }
}


/*
  This is a very simple animation. Not much to it, but a nice effect.  My intent was mainly to create
  the falling effect, but some people think the best part is the return where they all rapidly return
  to their original position on the top.  Looks like a whole bunch of guns going off.
*/

void randomFall() {
  int x3, y3, count3 = 0, mywait = 25;
  byte upDown[8][8];

  for (int x = 0; x < 8; x++)
    for (int y = 0; y < 8; y++)
    {
      ledOn (x, y, 7);
      upDown[x][y] = 0;
    }

  delay(500);
  while (count3 < 64) {
    x3 = random(8);
    y3 = random(8);
    if (upDown[x3][y3] == 0) {
      upDown[x3][y3] = 1;
      count3++;
      for (int z = 7; z > 0; z--) {
        ledOff(x3, y3, z);
        ledOn(x3, y3, z - 1);
        delay((z * mywait) / 5);
      }
    }
  }
  delay(100);
  count3 = 0;

  while (count3 < 64) {
    x3 = random(8);
    y3 = random(8);
    if (upDown[x3][y3] == 1) {
      upDown[x3][y3] = 0;
      count3++;
      for (int z = 0; z < 7; z++) {
        ledOff(x3, y3, z);
        ledOn(x3, y3, z + 1);
        delay(mywait / 10);
      }
    }
  }
}


//This is the wild mouse animation
void Mouse1() {
  int history[8][3];      // Where the trail is stored - 3 position markers, and the color.
  int historyCount = 0;    // Position counter for the trail
  int dir = 1;
  int xyz = 1;             // Current dimension of motion, as accross layers, across panels, or across columns
  int xx = 7, yy = 7, zz = 7; // x, y, and z coordinants for current position
  int xx1, yy1, zz1;       // temporary place to store coordinates as thery're changing
  memset(history, 8, sizeof history);
  for (int myloop = 0; myloop < 760; myloop++)
  {
    xx1 = xx;
    yy1 = yy;
    zz1 = zz;
    switch (xyz)
    {
      case 1: // moving across layers
        if (dir == 1)
        { // if moving higher?
          xx++;
          if (xx > 7)
          { // Did we hit an edge on the high end?
            xx = 7;
            xyz = 2; // if so, change direction
            if (yy < 4)
              dir = 1;  // in new direction, move toward the middle
            else
              dir = -1;
          }
        }
        if (dir == -1) { // if moving lower?
          xx--;
          if (xx < 0) { // Did we hit an edge on the low end?
            xx = 0;
            xyz = 3; // if so, change direction
            if (zz < 4) { // in new direction, move toward the middle
              dir = 1;
            }
            else {
              dir = -1;
            }
          }
        }

        if (random(5) == 0) { // one in 5 times, change move dimension in the  middle of the cube
          if (random(2) == 0) { // which way to change dimension?
            xyz = 2; // move across panels
          }
          else {
            xyz = 3; // move across columns
          }
        }
        break;

      case 2: // moving across panels  (similar to above)
        if (dir == 1) {
          yy++;

          if (yy > 7) {
            yy = 7;
            xyz = 3;
            if (zz < 4) {
              dir = 1;
            }
            else {
              dir = -1;
            }
          }
        }
        if (dir == -1) {
          yy--;
          if (yy < 0) {
            yy = 0;
            xyz = 1;
            if (xx < 4) {
              dir = 1;
            }
            else {
              dir = -1;
            }
          }
        }

        if (random(5) == 0) {
          if (random(2) == 0) {
            xyz = 3;
          }
          else {
            xyz = 1;
          }
        }
        break;
      case 3:  // moving across columns, similar to above
        if (dir == 1) {
          zz++;
          if (zz > 7) {
            zz = 7;
            xyz = 1;
            if (xx < 4) {
              dir = 1;
            }
            else {
              dir = -1;
            }
          }
        }
        if (dir == -1) {
          zz--;
          if (zz < 0) {
            zz = 0;
            xyz = 2;
            if (yy < 4) {
              dir = 1;
            }
            else {
              dir = -1;
            }
          }
        }

        if (random(5) == 0) {
          if (random(2) == 0) {
            xyz = 1;
          }
          else {
            xyz = 2;
          }
        }
        break;
    } // switch

    history[historyCount][0] = xx1; // move the current position into the  history so we can control the trail
    history[historyCount][1] = yy1;
    history[historyCount][2] = zz1;

    for (int mycount = 0; mycount < 8; mycount++) { // update the cube with new  trail data
      xx1 = history[mycount][0];
      yy1 = history[mycount][1];
      zz1 = history[mycount][2];
      if(inrange(xx1, yy1, zz))ledOn(xx1, yy1, zz1);
    }

    historyCount++;
    if (historyCount > 7) { // keep the history counter in bounds
      historyCount = 0;
    }

    delay(22);  // delay to control speed
    clearCube();  // smaller than clearing the path originally to clear the trail.  Looks same
  } 
}


// This animation is similar to the sinewave animation, but instead of running  the sine 
// from the middle outward, it displays across the diagonal of the cube. While  it uses
// the cosine, it could just as easily be done with sine. 
void Cosine(int myNumber){  // myNumber is number of iterations of this  animation
  int z;
  for (int count=0; count<myNumber; count++){  
    for (int i=0; i<40; i++){   //it takes 40 steps to complete one full cycle
      for (byte xx=0; xx<8; xx++){ 
        for (byte yy=0; yy<8; yy++){
          z=((byte)(4+cos((xx/2.23)+(yy/2.23)+(float)i/6.28)*4)); // the  actual z calculation
          if (z>7) { // this is necessary because a one spot the cos is  actually one
            z=7;     // and tries to set z at 8.
          }
          ledOn(xx,yy, z); 
        }
      } 
      delay(10);       // Increase or decrease to change speed of this  animation 
      clearCube();    // clear the cube
    }
  }
}


/*  Paddles basically steals from another animations.  It is based
    on the Simple_Rotation scheme introduced in template verson 5, where
    we were rotating a red arrow. In this version, we changed the arrow
    and inverted what is lit up creating something like a frame with
    a hollow center.  Then for each color, we rotate around a different
    axis.  */

void paddles() {
  int rotations = 1, mydelay = 10;
  // This is a pattern to be rotated. It can be anything fitting in an 8x8 panel.
  int const myPattern[8][8]  = {
    {1, 1, 1, 1, 1, 1, 1, 1,},
    {1, 1, 0, 0, 0, 0, 1, 1,},
    {1, 0, 0, 0, 0, 0, 0, 1,},
    {1, 0, 0, 1, 1, 0, 0, 1,},
    {1, 0, 0, 1, 1, 0, 0, 1,},
    {1, 0, 0, 0, 0, 0, 0, 1,},
    {1, 1, 0, 0, 0, 0, 1, 1,},
    {1, 1, 1, 1, 1, 1, 1, 1,},
  };
  // This is the table that tells Y how to move for each X as we move though 45 degrees.
  int const table[32] = {
    0, 1, 2, 3, 4, 5, 6, 7, 1, 1, 2, 3, 4, 5, 6, 6, 2, 2, 3, 3, 4, 4, 5, 5, 3, 3, 3, 3, 4, 4, 4, 4
  };
  for (int j = 0; j < 35; j++) { // Main loop
    if (j > 5)  {
      mydelay = 15;
    }
    if (j > 10) {
      mydelay = 20;
    }
    if (j > 24) {
      mydelay = 15;
    }
    if (j > 29) {
      mydelay = 10;
    }
    for (int x = 0; x < rotations; x++) { // move first 45 degrees
      for (int count = 0; count < 4; count++) {
        for (int layer = 0; layer < 8; layer++) {
          for (int x = 0; x < 8; x++) {
            if (myPattern[layer][x] > 0) {
              if (j < 25) {
                ledOn(x, table[count * 8 + x], layer);
              }
              if (j > 5 && j < 30) {
                ledOn(layer, x, table[count * 8 + x]);
              }
              if (j > 10) {
                ledOn(table[count * 8 + x], layer, x);
              }
            }
          }
        }
        delay(mydelay);
        clearCube();
      }
      for (int count = 0; count < 4; count++) { // move second 45 degrees
        for (int layer = 0; layer < 8; layer++) {
          for (int x = 0; x < 8; x++) {
            if (myPattern[layer][x] > 0) {
              if (j < 25) {
                ledOn(x, table[31 - (count * 8 + x)], layer);
              }
              if (j > 5 && j < 30) {
                ledOn(layer, x, table[31 - (count * 8 + x)]);
              }
              if (j > 10) {
                ledOn(table[31 - (count * 8 + x)], layer, x);
              }
            }
          }
        }
        delay(mydelay);
        clearCube();
      }

      for (int count = 1; count < 4; count++) { // move third 45 degrees
        for (int layer = 0; layer < 8; layer++) {
          for (int x = 0; x < 8; x++) {
            if (myPattern[layer][x] > 0) { //???
              if (j < 25) {
                ledOn(table[count * 8 + x], 7 - x, layer);
              }
              if (j > 5 && j < 30) {
                ledOn(layer, table[count * 8 + x], 7 - x);
              }
              if (j > 10) {
                ledOn(7 - x, layer, table[count * 8 + x]);
              }
            }
          }
        }
        delay(mydelay);
        clearCube();
      }

      for (int count = 0; count < 3; count++) { // move fourth 45 degrees
        for (int layer = 0; layer < 8; layer++) {
          for (int x = 0; x < 8; x++) {
            if (myPattern[layer][x] > 0) {
              if (j < 25) {
                ledOn(table[31 - (count * 8 + x)], 7 - x, layer);
              }
              if (j > 5 && j < 30) {
                ledOn(layer, table[31 - (count * 8 + x)], 7 - x);
              }
              if (j > 10) {
                ledOn(7 - x, layer, table[31 - (count * 8 + x)]);
              }
            }
          }
        }
        delay(mydelay);
        clearCube();
      }

      for (int count = 0; count < 4; count++) { // move fifth 45 degrees
        for (int layer = 0; layer < 8; layer++) {
          for (int x = 0; x < 8; x++) {
            if (myPattern[layer][x] > 0) {
              if (j < 25) {
                ledOn(x, table[count * 8 + x], layer);
              }
              if (j > 5 && j < 30) {
                ledOn(layer, x, table[count * 8 + x]);
              }
              if (j > 10) {
                ledOn(table[count * 8 + x], layer, x);
              }
            }
          }
        }
        delay(mydelay);
        clearCube();
      }

      for (int count = 1; count < 4; count++) { // move sixth 45 degrees
        for (int layer = 0; layer < 8; layer++) {
          for (int x = 0; x < 8; x++) {
            if (myPattern[layer][x] > 0) {
              if (j < 25) {
                ledOn(x, table[31 - (count * 8 + x)], layer);
              }
              if (j > 5 && j < 30) {
                ledOn(layer, x, table[31 - (count * 8 + x)]);
              }
              if (j > 10) {
                ledOn(table[31 - (count * 8 + x)], layer, x);
              }
            }
          }
        }
     delay(mydelay);
        clearCube();
      }

      for (int count = 1; count < 4; count++) { // move seventh 45 degrees
        for (int layer = 0; layer < 8; layer++) {
          for (int x = 0; x < 8; x++) {
            if (myPattern[layer][x] > 0) {
              if (j < 25) {
                ledOn(table[count * 8 + x], 7 - x, layer);
              }
              if (j > 5 && j < 30) {
                ledOn(layer, table[count * 8 + x], 7 - x);
              }
              if (j > 10) {
                ledOn(7 - x, layer, table[count * 8 + x]);
              }
            }
          }
        }
      delay(mydelay);
        clearCube();
      }
      for (int count = 0; count < 3; count++) { // move last 45 degrees
        for (int layer = 0; layer < 8; layer++) {
          for (int x = 0; x < 8; x++) {
            if (myPattern[layer][x] > 0) {
              if (j < 25) {
                ledOn(table[31 - (count * 8 + x)], 7 - x, layer);
              }
              if (j > 5 && j < 30) {
                ledOn(layer, table[31 - (count * 8 + x)], 7 - x);
              }
              if (j > 10) {
                ledOn(7 - x, layer, table[31 - (count * 8 + x)]);
              }
            }
          }
        }
        delay(mydelay);
        clearCube();
      }
    }
  }
}


// MazeMice is derived from my previos Mouse animation.  There are three
// mice this time, and the "tails" are much shorter. Nothing fancy, but
// a lot of repetitious code!
void mazemice() {
  int dir1 = 1, dir2 = 1, dir3 = 1;
  int xx1 = 7, xx2 = 7, xx3 = 7, xx11, xx12, xx13, xx21, xx22, xx23, xx31, xx32, xx33;
  int yy1 = 7, yy2 = 7, yy3 = 7, yy11, yy12, yy13, yy21, yy22, yy23, yy31, yy32, yy33;
  int zz1 = 7, zz2 = 7, zz3 = 7, zz11, zz12, zz13, zz21, zz22, zz23, zz31, zz32, zz33;
  int xyz1 = 1, xyz2 = 1, xyz3 = 1;
  for (int myloop = 0; myloop < 820; myloop = myloop + 2) {
    ledOn(xx1, yy1, zz1);
    ledOn(xx2, yy2, zz2);
    ledOn(xx3, yy3, zz3);
    if (myloop > 4)
    {
      ledOn(xx11, yy11, zz11);
      ledOn(xx21, yy21, zz21);
      ledOn(xx31, yy31, zz31);
      ledOn(xx12, yy12, zz12);
      ledOn(xx22, yy22, zz22);
      ledOn(xx32, yy32, zz32);
    }
   
    delay(20);

    if (myloop > 4)
    {
      ledOff(xx13, yy13, zz13);
      ledOff(xx23, yy23, zz23);
      ledOff(xx33, yy33, zz33);
    }
    xx13 = xx12;  yy13 = yy12;  zz13 = zz12;
    xx12 = xx11;  yy12 = yy11;  zz12 = zz11;
    xx11 = xx1;  yy11 = yy1;  zz11 = zz1;
    xx23 = xx22;  yy23 = yy22;  zz23 = zz22;
    xx22 = xx21;  yy22 = yy21;  zz22 = zz21;
    xx21 = xx2;  yy21 = yy2;  zz21 = zz2;
    xx33 = xx32;  yy33 = yy32;  zz33 = zz32;
    xx32 = xx31;  yy32 = yy31;  zz32 = zz31;
    xx31 = xx3;  yy31 = yy3;  zz31 = zz3;
    // For Red, everything is 1
    switch (xyz1) {
      case 1: // moving across layers
        if (dir1 == 1) { // if moving higher?
          xx1++;
          if (xx1 > 7) { // Did we hit an edge on the high end?
            xx1 = 7;
            xyz1 = 2; // if so, change direction
            if (yy1 < 4) { // in new direction, move toward the middle
              dir1 = 1;
            }
            else {
              dir1 = -1;
            }
          }
        }
        if (dir1 == -1) { // if moving lower?
          xx1--;
          if (xx1 < 0) { // Did we hit an edge on the low end?
            xx1 = 0;
            xyz1 = 3; // if so, change direction
            if (zz1 < 4) { // in new direction, move toward the middle
              dir1 = 1;
            }
            else {
              dir1 = -1;
            }
          }
        }

        if (random(5) == 0) { // one in 5 times, change move dimension in the  middle of the cube
          if (random(2) == 0) { // which way to change dimension?
            xyz1 = 2; // move across panels
          }
          else {
            xyz1 = 3; // move across columns
          }
        }
        break;

      case 2: // moving across panels  (similar to above)
        if (dir1 == 1) {
          yy1++;

          if (yy1 > 7) {
            yy1 = 7;
            xyz1 = 3;
            if (zz1 < 4) {
              dir1 = 1;
            }
            else {
              dir1 = -1;
            }
          }
        }
        if (dir1 == -1) {
          yy1--;
          if (yy1 < 0) {
            yy1 = 0;
            xyz1 = 1;
            if (xx1 < 4) {
              dir1 = 1;
            }
            else {
              dir1 = -1;
            }
          }
        }

        if (random(5) == 0) {
          if (random(2) == 0) {
            xyz1 = 3;
          }
          else {
            xyz1 = 1;
          }
        }
        break;
      case 3:  // moving across columns, similar to above
        if (dir1 == 1) {
          zz1++;
          if (zz1 > 7) {
            zz1 = 7;
            xyz1 = 1;
            if (xx1 < 4) {
              dir1 = 1;
            }
            else {
              dir1 = -1;
            }
          }
        }
        if (dir1 == -1) {
          zz1--;
          if (zz1 < 0) {
            zz1 = 0;
            xyz1 = 2;
            if (yy1 < 4) {
              dir1 = 1;
            }
            else {
              dir1 = -1;
            }
          }
        }

        if (random(5) == 0) {
          if (random(2) == 0) {
            xyz1 = 1;
          }
          else {
            xyz1 = 2;
          }
        }
        break;
    }
    // For Green, everything is 2
    switch (xyz2) {
      case 1: // moving across layers
        if (dir2 == 1) { // if moving higher?
          xx2++;
          if (xx2 > 7) { // Did we hit an edge on the high end?
            xx2 = 7;
            xyz2 = 2; // if so, change direction
            if (yy2 < 4) { // in new direction, move toward the middle
              dir2 = 1;
            }
            else {
              dir2 = -1;
            }
          }
        }
        if (dir2 == -1) { // if moving lower?
          xx2--;
          if (xx2 < 0) { // Did we hit an edge on the low end?
            xx2 = 0;
            xyz2 = 3; // if so, change direction
            if (zz1 < 4) { // in new direction, move toward the middle
              dir2 = 1;
            }
            else {
              dir2 = -1;
            }
          }
        }

        if (random(5) == 0) { // one in 5 times, change move dimension in the  middle of the cube
          if (random(2) == 0) { // which way to change dimension?
            xyz2 = 2; // move across panels
          }
          else {
            xyz2 = 3; // move across columns
          }
        }
        break;

      case 2: // moving across panels  (similar to above)
        if (dir2 == 1) {
          yy2++;

          if (yy2 > 7) {
            yy2 = 7;
            xyz2 = 3;
            if (zz2 < 4) {
              dir2 = 1;
            }
            else {
              dir2 = -1;
            }
          }
        }
        if (dir2 == -1) {
          yy2--;
          if (yy2 < 0) {
            yy2 = 0;
            xyz2 = 1;
            if (xx2 < 4) {
              dir2 = 1;
            }
            else {
              dir2 = -1;
            }
          }
        }

        if (random(5) == 0) {
          if (random(2) == 0) {
            xyz2 = 3;
          }
          else {
            xyz2 = 1;
          }
        }
        break;
      case 3:  // moving across columns, similar to above
        if (dir2 == 1) {
          zz2++;
          if (zz2 > 7) {
            zz2 = 7;
            xyz2 = 1;
            if (xx2 < 4) {
              dir2 = 1;
            }
            else {
              dir1 = -1;
            }
          }
        }
        if (dir2 == -1) {
          zz2--;
          if (zz2 < 0) {
            zz2 = 0;
            xyz2 = 2;
            if (yy2 < 4) {
              dir2 = 1;
            }
            else {
              dir2 = -1;
            }
          }
        }

        if (random(5) == 0) {
          if (random(2) == 0) {
            xyz2 = 1;
          }
          else {
            xyz2 = 2;
          }
        }
        break;
    }
    // For Blue everything is 3
    switch (xyz3) {
      case 1: // moving across layers
        if (dir3 == 1) { // if moving higher?
          xx3++;
          if (xx3 > 7) { // Did we hit an edge on the high end?
            xx3 = 7;
            xyz3 = 2; // if so, change direction
            if (yy3 < 4) { // in new direction, move toward the middle
              dir3 = 1;
            }
            else {
              dir3 = -1;
            }
          }
        }
        if (dir3 == -1) { // if moving lower?
          xx3--;
          if (xx3 < 0) { // Did we hit an edge on the low end?
            xx3 = 0;
            xyz3 = 3; // if so, change direction
            if (zz3 < 4) { // in new direction, move toward the middle
              dir3 = 1;
            }
            else {
              dir3 = -1;
            }
          }
        }

        if (random(5) == 0) { // one in 5 times, change move dimension in the  middle of the cube
          if (random(2) == 0) { // which way to change dimension?
            xyz3 = 2; // move across panels
          }
          else {
            xyz3 = 3; // move across columns
          }
        }
        break;

      case 2: // moving across panels  (similar to above)
        if (dir3 == 1) {
          yy3++;

          if (yy3 > 7) {
            yy3 = 7;
            xyz3 = 3;
            if (zz3 < 4) {
              dir3 = 1;
            }
            else {
              dir3 = -1;
            }
          }
        }
        if (dir3 == -1) {
          yy3--;
          if (yy3 < 0) {
            yy3 = 0;
            xyz3 = 1;
            if (xx3 < 4) {
              dir3 = 1;
            }
            else {
              dir3 = -1;
            }
          }
        }

        if (random(5) == 0) {
          if (random(2) == 0) {
            xyz3 = 3;
          }
          else {
            xyz3 = 1;
          }
        }
        break;
      case 3:  // moving across columns, similar to above
        if (dir3 == 1) {
          zz3++;
          if (zz3 > 7) {
            zz3 = 7;
            xyz3 = 1;
            if (xx3 < 4) {
              dir3 = 1;
            }
            else {
              dir3 = -1;
            }
          }
        }
        if (dir3 == -1) {
          zz3--;
          if (zz3 < 0) {
            zz3 = 0;
            xyz3 = 2;
            if (yy3 < 4) {
              dir3 = 1;
            }
            else {
              dir3 = -1;
            }
          }
        }

        if (random(5) == 0) {
          if (random(2) == 0) {
            xyz3 = 1;
          }
          else {
            xyz3 = 2;
          }
        }
        break;
    }
  }
}




// whatThe is the result of a simple experiment. The idea was have each layer going around
// (using the atom table) at a different speed. A lot of work just to end up with a
// simple animation.  Then let's try to put everything back by reversing the process.
// That doesn't quite work.  I had to fudge it a little.  But here it is.
void whatThe() {

  for (int k = 0; k < 3; k++)
  { // Main loop
    byte index0 = 0, index1 = 0, index2 = 0, index3 = 0, index4 = 0, index5 = 0, index6 = 0, index7 = 0;
    for (int j = 0; j < 1000; j++) {
      if (j % 20 == 0) {
        index0++;
      }
      if (index0 > 19) {
        index0 = 0;
      }
      ledOn(atomTable[index0][0], atomTable[index0][1], 0);
      if (j % 19 == 0) {
        index1++;
      }
      if (index1 > 19) {
        index1 = 0;
      }
      ledOn(atomTable[index1][0], atomTable[index1][1], 1);
      if (j % 18 == 0) {
        index2++;
      }
      if (index2 > 19) {
        index2 = 0;
      }
      ledOn(atomTable[index2][0], atomTable[index2][1], 2);
      if (j % 17 == 0) {
        index3++;
      }
      if (index3 > 19) {
        index3 = 0;
      }
      ledOn(atomTable[index3][0], atomTable[index3][1], 3);
      if (j % 16 == 0) {
        index4++;
      }
      if (index4 > 19) {
        index4 = 0;
      }
      ledOn(atomTable[index4][0], atomTable[index4][1], 4);
      if (j % 15 == 0) {
        index5++;
      }
      if (index5 > 19) {
        index5 = 0;
      }
      ledOn(atomTable[index5][0], atomTable[index5][1], 5);
      if (j % 14 == 0) {
        index6++;
      }
      if (index6 > 19) {
        index6 = 0;
      }
      ledOn(atomTable[index6][0], atomTable[index6][1], 6);
      if (j % 13 == 0) {
        index7++;
      }
      if (index7 > 19) {
        index7 = 0;
      }
      ledOn(atomTable[index7][0], atomTable[index7][1], 7);
      if (xit) return;
      if (j % 10 < 1) {
        delay(10 + 10 / (j / 100 + 10));
        clearAtom();
      }
    }
    for (int j = 1000; j < 3000; j++) {
      if (j % 16 == 0) {
        index0++;
      }
      if (index0 > 19) {
        index0 = 0;
      }
      ledOn(atomTable[index0][0], atomTable[index0][1], 0);
      if (j % 16 == 0) {
        index1++;
      }
      if (index1 > 19) {
        index1 = 0;
      }
      ledOn(atomTable[index1][0], atomTable[index1][1], 1);
      if (j % 16 == 0) {
        index2++;
      }
      if (index2 > 19) {
        index2 = 0;
      }
      ledOn(atomTable[index2][0], atomTable[index2][1], 2);
      if (j % 16 == 0) {
        index3++;
      }
      if (index3 > 19) {
        index3 = 0;
      }
      ledOn(atomTable[index3][0], atomTable[index3][1], 3);
      if (j % 16 == 0) {
        index4++;
      }
      if (index4 > 19) {
        index4 = 0;
      }
      ledOn(atomTable[index4][0], atomTable[index4][1], 4);
      if (j % 16 == 0) {
        index5++;
      }
      if (index5 > 19) {
        index5 = 0;
      }
      ledOn(atomTable[index5][0], atomTable[index5][1], 5);
      if (j % 16 == 0) {
        index6++;
      }
      if (index6 > 19) {
        index6 = 0;
      }
      ledOn(atomTable[index6][0], atomTable[index6][1], 6);
      if (j % 16 == 0) {
        index7++;
      }
      if (index7 > 19) {
        index7 = 0;
      }
      ledOn(atomTable[index7][0], atomTable[index7][1], 7);
      if (xit) return;
      if (j % 10 < 1) {
        delay(10);
        clearAtom();
      }
    }

    for (int j = 3000; j < 4150; j++) {
      if (j % 13 == 0) {
        index0++;
      }
      if (index0 > 19) {
        index0 = 0;
      }
      ledOn(atomTable[index0][0], atomTable[index0][1], 0);
      if (j % 14 == 0) {
        index1++;
      }
      if (index1 > 19) {
        index1 = 0;
      }
      ledOn(atomTable[index1][0], atomTable[index1][1], 1);
      if (j % 15 == 0) {
        index2++;
      }
      if (index2 > 19) {
        index2 = 0;
      }
      ledOn(atomTable[index2][0], atomTable[index2][1], 2);
      if (j % 16 == 0) {
        index3++;
      }
      if (index3 > 19) {
        index3 = 0;
      }
      ledOn(atomTable[index3][0], atomTable[index3][1], 3);
      if (j % 17 == 0) {
        index4++;
      }
      if (index4 > 19) {
        index4 = 0;
      }
      ledOn(atomTable[index4][0], atomTable[index4][1], 4);
      if (j % 18 == 0) {
        index5++;
      }
      if (index5 > 19) {
        index5 = 0;
      }
      ledOn(atomTable[index5][0], atomTable[index5][1], 5);
      if (j % 19 == 0) {
        index6++;
      }
      if (index6 > 19) {
        index6 = 0;
      }
      ledOn(atomTable[index6][0], atomTable[index6][1], 6);
      if (j % 20 == 0) {
        index7++;
      }
      if (index7 > 19) {
        index7 = 0;
      }
      ledOn(atomTable[index7][0], atomTable[index7][1], 7);
      if (xit) return;
      if (j % 10 < 1) {
        delay(10);
        clearAtom();
      }
    }
    clearAtom();
    for (int j = 0; j < 8; j++) {
      ledOn(2, 0, j);
    }
    delay(25);
  }
}



void chaos(int iterations, int xdelay) {
  byte location[8][8][2];  //this array stores the location and direction of  each column
  for (int k = 0; k < iterations; k++)
  {
    for (byte xx = 0; xx < 8; xx++) // this is the setup routine.
      for (byte yy = 0; yy < 8; yy++)
      {
        location[xx][yy][0] = random(7);
        if (location[xx][yy][0] > 0)
          location[xx][yy][0] = 10;
        // only ones at layer 0 are chosen.
        // other 3/4 of LEDs are banished to the 10th layer where they won't  be seen.
        location[xx][yy][1] = random(3); // select an initial direction of  travel: up, down, or stopped.
        if (location[xx][yy][0] < 8)     // if it's not on the 10th level,  assign it a color
          ledOn(xx, yy, location[xx][yy][0]); // and turn  it on.
      } // yy


    for (int j = 0;  j < 50; j++)
    { // now we put them in motion
      for (byte xx = 0; xx < 8; xx++)
        for (byte yy = 0; yy < 8; yy++)
        {
          if (location[xx][yy][0] < 8)
          { // if it's a valid location (not 10th  layer
            if (random(3) == 0)
            { // 1/3 of the time
              location[xx][yy][1] = random(3); //change direction: up, down,  or stopped
              for (int z = 0; z < 8; z++) // at this time erase everything in  this xx,yy column
                ledOff(xx, yy, z);
            }
            if (location[xx][yy][1] == 1)
            { // if it's going up,
              if (location[xx][yy][0] < 7) // and not already on the top floor
                location[xx][yy][0] = location[xx][yy][0] + 1; // move it up one
              else
              { // on the top floor?
                location[xx][yy][0] = location[xx][yy][0] - 1; // move down one
                location[xx][yy][1] == 2; // change direction to down
              }
            }
            if (location[xx][yy][1] == 2)
            { // if it's going down,
              if (location[xx][yy][0] > 0) // and not already on the ground  floor
                location[xx][yy][0] = location[xx][yy][0] - 1; // move it down  one
              else
              { // on the bottom floor?
                location[xx][yy][0] = location[xx][yy][0] + 1; // move up one
                location[xx][yy][1] == 1; //change direction to up
              }
            }
            ledOn(xx, yy, location[xx][yy][0]); // turn on  in new location
          } // if location
        } // yy
      delay(xdelay); // this moves pretty fast
    }  // j
    clearCube();    // clear the cube
  } // k
}
